#ifndef __SCRUFFY__CPP_PARGEN_H__
#define __SCRUFFY__CPP_PARGEN_H__

#include <mycpp/string.h>

#include <pargen/parser_element.h>
#include <pargen/grammar.h>

namespace Scruffy {

class CppElement : public Pargen::ParserElement
{
public:
    enum Type {
        _Scruffy_NotABrace,
        _Scruffy_NotAParenthesis,
        _Scruffy_SkipCompoundStatement,
        _Scruffy_SkipExpressionList,
        _Scruffy_SkipExceptionDeclaration,
        _Scruffy_GlobalScope,
        _Literal,
        _StringLiteral,
        _Identifier,
        _TranslationUnit,
        _PrimaryExpression,
        _IdExpression,
        _UnqualifiedId,
        _QualifiedId,
        _NestedNameSpecifier,
        _ClassOrNamespaceName,
        _PostfixExpression,
        _ExpressionList,
        _PseudoDestructorName,
        _UnaryExpression,
        _UnaryOperator,
        _NewExpression,
        _NewPlacement,
        _NewTypeId,
        _NewDeclarator,
        _DirectNewDeclarator,
        _NewInitializer,
        _DeleteExpression,
        _CastExpression,
        _PmExpression,
        _MultiplicativeExpression,
        _AdditiveExpression,
        _ShiftExpression,
        _RelationalExpression,
        _EqualityExpression,
        _AndExpression,
        _ExclusiveOrExpression,
        _InclusiveOrExpression,
        _LogicalAndExpression,
        _LogicalOrExpression,
        _ConditionalExpression,
        _AssignmentExpression,
        _AssignmentOperator,
        _Expression,
        _ConstantExpression,
        _Statement,
        _LabeledStatement,
        _ExpressionStatement,
        _CompoundStatement,
        _SelectionStatement,
        _Condition,
        _IterationStatement,
        _ForInitStatement,
        _JumpStatement,
        _DeclarationStatement,
        _DeclarationSeq,
        _Declaration,
        _BlockDeclaration,
        _SimpleDeclaration,
        _DeclSpecifier,
        _DeclSpecifierSeq,
        _StorageClassSpecifier,
        _FunctionSpecifier,
        _TypedefName,
        _TypeSpecifier,
        _SimpleTypeSpecifier,
        _TypeName,
        _ElaboratedTypeSpecifier,
        _EnumName,
        _EnumSpecifier,
        _EnumeratorList,
        _EnumeratorDefinition,
        _Enumerator,
        _NamespaceName,
        _NamespaceDefinition,
        _NamedNamespaceDefinition,
        _UnnamedNamespaceDefinition,
        _NamespaceBody,
        _NamespaceAliasDefinition,
        _QualifiedNamespaceSpecifier,
        _UsingDeclaration,
        _UsingDirective,
        _AsmDefinition,
        _LinkageSpecification,
        _InitDeclaratorList,
        _InitDeclarator,
        _Declarator,
        _DirectDeclarator,
        _PtrOperator,
        _CvQualifierSeq,
        _CvQualifier,
        _DeclaratorId,
        _TypeId,
        _TypeSpecifierSeq,
        _ParameterDeclarationClause,
        _ParameterDeclarationList,
        _ParameterDeclaration,
        _FunctionDefinition,
        _FunctionBody,
        _Initializer,
        _InitializerClause,
        _InitializerList,
        _ClassName,
        _ClassNameIdentifier,
        _ClassSpecifier,
        _ClassHead,
        _ClassKey,
        _MemberSpecification,
        _MemberDeclaration,
        _MemberDeclaratorList,
        _MemberDeclarator,
        _PureSpecifier,
        _ConstantInitializer,
        _BaseClause,
        _BaseSpecifierList,
        _BaseSpecifier,
        _AccessSpecifier,
        _ConversionFunctionId,
        _ConversionTypeId,
        _ConversionDeclarator,
        _CtorInitializer,
        _MemInitializerList,
        _MemInitializer,
        _MemInitializerId,
        _OperatorFunctionId,
        _Operator,
        _TemplateDeclaration,
        _TemplateParameterList,
        _TemplateParameter,
        _TypeParameter,
        _TemplateId,
        _TemplateName,
        _TemplateArgumentList,
        _TemplateArgument,
        _ExplicitInstantiation,
        _ExplicitSpecialization,
        _TryBlock,
        _FunctionTryBlock,
        _HandlerSeq,
        _Handler,
        _ExceptionDeclaration,
        _ThrowExpression,
        _ExceptionSpecification,
        _TypeIdList,
        _Grammar
    };

    const Type cpp_element_type;

    CppElement (Type type)
        : cpp_element_type (type)
    {
    }
};

class Cpp_Scruffy_NotABrace;
class Cpp_Scruffy_NotAParenthesis;
class Cpp_Scruffy_SkipCompoundStatement;
class Cpp_Scruffy_SkipExpressionList;
class Cpp_Scruffy_SkipExceptionDeclaration;
class Cpp_Scruffy_GlobalScope;
class Cpp_Literal;
class Cpp_StringLiteral;
class Cpp_Identifier;
class Cpp_TranslationUnit;
class Cpp_PrimaryExpression;
class Cpp_IdExpression;
class Cpp_UnqualifiedId;
class Cpp_QualifiedId;
class Cpp_NestedNameSpecifier;
class Cpp_ClassOrNamespaceName;
class Cpp_PostfixExpression;
class Cpp_ExpressionList;
class Cpp_PseudoDestructorName;
class Cpp_UnaryExpression;
class Cpp_UnaryOperator;
class Cpp_NewExpression;
class Cpp_NewPlacement;
class Cpp_NewTypeId;
class Cpp_NewDeclarator;
class Cpp_DirectNewDeclarator;
class Cpp_NewInitializer;
class Cpp_DeleteExpression;
class Cpp_CastExpression;
class Cpp_PmExpression;
class Cpp_MultiplicativeExpression;
class Cpp_AdditiveExpression;
class Cpp_ShiftExpression;
class Cpp_RelationalExpression;
class Cpp_EqualityExpression;
class Cpp_AndExpression;
class Cpp_ExclusiveOrExpression;
class Cpp_InclusiveOrExpression;
class Cpp_LogicalAndExpression;
class Cpp_LogicalOrExpression;
class Cpp_ConditionalExpression;
class Cpp_AssignmentExpression;
class Cpp_AssignmentOperator;
class Cpp_Expression;
class Cpp_ConstantExpression;
class Cpp_Statement;
class Cpp_LabeledStatement;
class Cpp_ExpressionStatement;
class Cpp_CompoundStatement;
class Cpp_SelectionStatement;
class Cpp_Condition;
class Cpp_IterationStatement;
class Cpp_ForInitStatement;
class Cpp_JumpStatement;
class Cpp_DeclarationStatement;
class Cpp_DeclarationSeq;
class Cpp_Declaration;
class Cpp_BlockDeclaration;
class Cpp_SimpleDeclaration;
class Cpp_DeclSpecifier;
class Cpp_DeclSpecifierSeq;
class Cpp_StorageClassSpecifier;
class Cpp_FunctionSpecifier;
class Cpp_TypedefName;
class Cpp_TypeSpecifier;
class Cpp_SimpleTypeSpecifier;
class Cpp_TypeName;
class Cpp_ElaboratedTypeSpecifier;
class Cpp_EnumName;
class Cpp_EnumSpecifier;
class Cpp_EnumeratorList;
class Cpp_EnumeratorDefinition;
class Cpp_Enumerator;
class Cpp_NamespaceName;
class Cpp_NamespaceDefinition;
class Cpp_NamedNamespaceDefinition;
class Cpp_UnnamedNamespaceDefinition;
class Cpp_NamespaceBody;
class Cpp_NamespaceAliasDefinition;
class Cpp_QualifiedNamespaceSpecifier;
class Cpp_UsingDeclaration;
class Cpp_UsingDirective;
class Cpp_AsmDefinition;
class Cpp_LinkageSpecification;
class Cpp_InitDeclaratorList;
class Cpp_InitDeclarator;
class Cpp_Declarator;
class Cpp_DirectDeclarator;
class Cpp_PtrOperator;
class Cpp_CvQualifierSeq;
class Cpp_CvQualifier;
class Cpp_DeclaratorId;
class Cpp_TypeId;
class Cpp_TypeSpecifierSeq;
class Cpp_ParameterDeclarationClause;
class Cpp_ParameterDeclarationList;
class Cpp_ParameterDeclaration;
class Cpp_FunctionDefinition;
class Cpp_FunctionBody;
class Cpp_Initializer;
class Cpp_InitializerClause;
class Cpp_InitializerList;
class Cpp_ClassName;
class Cpp_ClassNameIdentifier;
class Cpp_ClassSpecifier;
class Cpp_ClassHead;
class Cpp_ClassKey;
class Cpp_MemberSpecification;
class Cpp_MemberDeclaration;
class Cpp_MemberDeclaratorList;
class Cpp_MemberDeclarator;
class Cpp_PureSpecifier;
class Cpp_ConstantInitializer;
class Cpp_BaseClause;
class Cpp_BaseSpecifierList;
class Cpp_BaseSpecifier;
class Cpp_AccessSpecifier;
class Cpp_ConversionFunctionId;
class Cpp_ConversionTypeId;
class Cpp_ConversionDeclarator;
class Cpp_CtorInitializer;
class Cpp_MemInitializerList;
class Cpp_MemInitializer;
class Cpp_MemInitializerId;
class Cpp_OperatorFunctionId;
class Cpp_Operator;
class Cpp_TemplateDeclaration;
class Cpp_TemplateParameterList;
class Cpp_TemplateParameter;
class Cpp_TypeParameter;
class Cpp_TemplateId;
class Cpp_TemplateName;
class Cpp_TemplateArgumentList;
class Cpp_TemplateArgument;
class Cpp_ExplicitInstantiation;
class Cpp_ExplicitSpecialization;
class Cpp_TryBlock;
class Cpp_FunctionTryBlock;
class Cpp_HandlerSeq;
class Cpp_Handler;
class Cpp_ExceptionDeclaration;
class Cpp_ThrowExpression;
class Cpp_ExceptionSpecification;
class Cpp_TypeIdList;

class Cpp_Scruffy_NotABrace : public CppElement
{
public:
    Pargen::ParserElement_Token *any_token;

    Cpp_Scruffy_NotABrace ()
        : CppElement (CppElement::_Scruffy_NotABrace)
          , any_token (NULL)
    {
    }
};

void dump_cpp_Scruffy_NotABrace (Cpp_Scruffy_NotABrace const *, MyCpp::Size nest_level = 0);

class Cpp_Scruffy_NotAParenthesis : public CppElement
{
public:
    Pargen::ParserElement_Token *any_token;

    Cpp_Scruffy_NotAParenthesis ()
        : CppElement (CppElement::_Scruffy_NotAParenthesis)
          , any_token (NULL)
    {
    }
};

void dump_cpp_Scruffy_NotAParenthesis (Cpp_Scruffy_NotAParenthesis const *, MyCpp::Size nest_level = 0);

class Cpp_Scruffy_SkipCompoundStatement : public CppElement
{
public:
    enum Type {
        _A,
        _B
    };

    const Type scruffy_skip_compound_statement_type;

    Cpp_Scruffy_SkipCompoundStatement (Type type)
        : CppElement (CppElement::_Scruffy_SkipCompoundStatement),
          scruffy_skip_compound_statement_type (type)
    {
    }
};

class Cpp_Scruffy_SkipCompoundStatement_A : public Cpp_Scruffy_SkipCompoundStatement
{
public:
    MyCpp::List<Cpp_Scruffy_NotABrace*> scruffy_NotABraces;

    Cpp_Scruffy_SkipCompoundStatement_A ()
        : Cpp_Scruffy_SkipCompoundStatement (Cpp_Scruffy_SkipCompoundStatement::_A)
    {
    }
};

class Cpp_Scruffy_SkipCompoundStatement_B : public Cpp_Scruffy_SkipCompoundStatement
{
public:
    MyCpp::List<Cpp_Scruffy_SkipCompoundStatement*> scruffy_SkipCompoundStatements;

    Cpp_Scruffy_SkipCompoundStatement_B ()
        : Cpp_Scruffy_SkipCompoundStatement (Cpp_Scruffy_SkipCompoundStatement::_B)
    {
    }
};

void dump_cpp_Scruffy_SkipCompoundStatement (Cpp_Scruffy_SkipCompoundStatement const *, MyCpp::Size nest_level = 0);

class Cpp_Scruffy_SkipExpressionList : public CppElement
{
public:
    enum Type {
        _A,
        _B
    };

    const Type scruffy_skip_expression_list_type;

    Cpp_Scruffy_SkipExpressionList (Type type)
        : CppElement (CppElement::_Scruffy_SkipExpressionList),
          scruffy_skip_expression_list_type (type)
    {
    }
};

class Cpp_Scruffy_SkipExpressionList_A : public Cpp_Scruffy_SkipExpressionList
{
public:
    MyCpp::List<Cpp_Scruffy_NotAParenthesis*> scruffy_NotAParenthesiss;

    Cpp_Scruffy_SkipExpressionList_A ()
        : Cpp_Scruffy_SkipExpressionList (Cpp_Scruffy_SkipExpressionList::_A)
    {
    }
};

class Cpp_Scruffy_SkipExpressionList_B : public Cpp_Scruffy_SkipExpressionList
{
public:
    MyCpp::List<Cpp_Scruffy_SkipExpressionList*> scruffy_SkipExpressionLists;

    Cpp_Scruffy_SkipExpressionList_B ()
        : Cpp_Scruffy_SkipExpressionList (Cpp_Scruffy_SkipExpressionList::_B)
    {
    }
};

void dump_cpp_Scruffy_SkipExpressionList (Cpp_Scruffy_SkipExpressionList const *, MyCpp::Size nest_level = 0);

class Cpp_Scruffy_SkipExceptionDeclaration : public CppElement
{
public:
    enum Type {
        _A,
        _B
    };

    const Type scruffy_skip_exception_declaration_type;

    Cpp_Scruffy_SkipExceptionDeclaration (Type type)
        : CppElement (CppElement::_Scruffy_SkipExceptionDeclaration),
          scruffy_skip_exception_declaration_type (type)
    {
    }
};

class Cpp_Scruffy_SkipExceptionDeclaration_A : public Cpp_Scruffy_SkipExceptionDeclaration
{
public:
    MyCpp::List<Cpp_Scruffy_NotAParenthesis*> scruffy_NotAParenthesiss;

    Cpp_Scruffy_SkipExceptionDeclaration_A ()
        : Cpp_Scruffy_SkipExceptionDeclaration (Cpp_Scruffy_SkipExceptionDeclaration::_A)
    {
    }
};

class Cpp_Scruffy_SkipExceptionDeclaration_B : public Cpp_Scruffy_SkipExceptionDeclaration
{
public:
    MyCpp::List<Cpp_Scruffy_SkipExceptionDeclaration*> scruffy_SkipExceptionDeclarations;

    Cpp_Scruffy_SkipExceptionDeclaration_B ()
        : Cpp_Scruffy_SkipExceptionDeclaration (Cpp_Scruffy_SkipExceptionDeclaration::_B)
    {
    }
};

void dump_cpp_Scruffy_SkipExceptionDeclaration (Cpp_Scruffy_SkipExceptionDeclaration const *, MyCpp::Size nest_level = 0);

class Cpp_Scruffy_GlobalScope : public CppElement
{
public:

    Cpp_Scruffy_GlobalScope ()
        : CppElement (CppElement::_Scruffy_GlobalScope)
    {
    }
};

void dump_cpp_Scruffy_GlobalScope (Cpp_Scruffy_GlobalScope const *, MyCpp::Size nest_level = 0);

class Cpp_Literal : public CppElement
{
public:
    Pargen::ParserElement_Token *any_token;

    Cpp_Literal ()
        : CppElement (CppElement::_Literal)
          , any_token (NULL)
    {
    }
};

void dump_cpp_Literal (Cpp_Literal const *, MyCpp::Size nest_level = 0);

class Cpp_StringLiteral : public CppElement
{
public:
    Pargen::ParserElement_Token *any_token;

    Cpp_StringLiteral ()
        : CppElement (CppElement::_StringLiteral)
          , any_token (NULL)
    {
    }
};

void dump_cpp_StringLiteral (Cpp_StringLiteral const *, MyCpp::Size nest_level = 0);

class Cpp_Identifier : public CppElement
{
public:
    Pargen::ParserElement_Token *any_token;

    Cpp_Identifier ()
        : CppElement (CppElement::_Identifier)
          , any_token (NULL)
    {
    }
};

void dump_cpp_Identifier (Cpp_Identifier const *, MyCpp::Size nest_level = 0);

class Cpp_TranslationUnit : public CppElement
{
public:
    MyCpp::List<Cpp_Declaration*> declarations;

    Cpp_TranslationUnit ()
        : CppElement (CppElement::_TranslationUnit)
    {
    }
};

void dump_cpp_TranslationUnit (Cpp_TranslationUnit const *, MyCpp::Size nest_level = 0);

bool cpp_accept_primary_expression (
        Cpp_PrimaryExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_PrimaryExpression : public CppElement
{
public:
    enum Type {
        _Literal,
        _This,
        _Braces,
        _IdExpression
    };

    const Type primary_expression_type;

    Cpp_PrimaryExpression (Type type)
        : CppElement (CppElement::_PrimaryExpression),
          primary_expression_type (type)
    {
    }
};

bool cpp_accept_primary_expression (
        Cpp_PrimaryExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_PrimaryExpression_Literal : public Cpp_PrimaryExpression
{
public:
    Cpp_Literal *literal;

    Cpp_PrimaryExpression_Literal ()
        : Cpp_PrimaryExpression (Cpp_PrimaryExpression::_Literal)
          , literal (NULL)
    {
    }
};

class Cpp_PrimaryExpression_This : public Cpp_PrimaryExpression
{
public:

    Cpp_PrimaryExpression_This ()
        : Cpp_PrimaryExpression (Cpp_PrimaryExpression::_This)
    {
    }
};

class Cpp_PrimaryExpression_Braces : public Cpp_PrimaryExpression
{
public:
    Cpp_Expression *expression;

    Cpp_PrimaryExpression_Braces ()
        : Cpp_PrimaryExpression (Cpp_PrimaryExpression::_Braces)
          , expression (NULL)
    {
    }
};

bool cpp_begin_id (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_PrimaryExpression_IdExpression : public Cpp_PrimaryExpression
{
public:
    Cpp_IdExpression *idExpression;

    Cpp_PrimaryExpression_IdExpression ()
        : Cpp_PrimaryExpression (Cpp_PrimaryExpression::_IdExpression)
          , idExpression (NULL)
    {
    }
};

void dump_cpp_PrimaryExpression (Cpp_PrimaryExpression const *, MyCpp::Size nest_level = 0);

class Cpp_IdExpression : public CppElement
{
public:
    enum Type {
        _QualifiedId,
        _UnqualifiedId
    };

    const Type id_expression_type;

    Cpp_IdExpression (Type type)
        : CppElement (CppElement::_IdExpression),
          id_expression_type (type)
    {
    }
};

class Cpp_IdExpression_QualifiedId : public Cpp_IdExpression
{
public:
    Cpp_QualifiedId *qualifiedId;

    Cpp_IdExpression_QualifiedId ()
        : Cpp_IdExpression (Cpp_IdExpression::_QualifiedId)
          , qualifiedId (NULL)
    {
    }
};

bool cpp_begin_nested_name (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_IdExpression_UnqualifiedId : public Cpp_IdExpression
{
public:
    Cpp_UnqualifiedId *unqualifiedId;

    Cpp_IdExpression_UnqualifiedId ()
        : Cpp_IdExpression (Cpp_IdExpression::_UnqualifiedId)
          , unqualifiedId (NULL)
    {
    }
};

void dump_cpp_IdExpression (Cpp_IdExpression const *, MyCpp::Size nest_level = 0);

class Cpp_UnqualifiedId : public CppElement
{
public:
    enum Type {
        _Destructor,
        _OperatorFunction,
        _ConversionFunction,
        _Template,
        _Identifier
    };

    const Type unqualified_id_type;

    Cpp_UnqualifiedId (Type type)
        : CppElement (CppElement::_UnqualifiedId),
          unqualified_id_type (type)
    {
    }
};

class Cpp_UnqualifiedId_Destructor : public Cpp_UnqualifiedId
{
public:
    Cpp_ClassName *className;

    Cpp_UnqualifiedId_Destructor ()
        : Cpp_UnqualifiedId (Cpp_UnqualifiedId::_Destructor)
          , className (NULL)
    {
    }
};

class Cpp_UnqualifiedId_OperatorFunction : public Cpp_UnqualifiedId
{
public:
    Cpp_OperatorFunctionId *operatorFunctionId;

    Cpp_UnqualifiedId_OperatorFunction ()
        : Cpp_UnqualifiedId (Cpp_UnqualifiedId::_OperatorFunction)
          , operatorFunctionId (NULL)
    {
    }
};

class Cpp_UnqualifiedId_ConversionFunction : public Cpp_UnqualifiedId
{
public:
    Cpp_ConversionFunctionId *conversionFunctionId;

    Cpp_UnqualifiedId_ConversionFunction ()
        : Cpp_UnqualifiedId (Cpp_UnqualifiedId::_ConversionFunction)
          , conversionFunctionId (NULL)
    {
    }
};

class Cpp_UnqualifiedId_Template : public Cpp_UnqualifiedId
{
public:
    Cpp_TemplateId *templateId;

    Cpp_UnqualifiedId_Template ()
        : Cpp_UnqualifiedId (Cpp_UnqualifiedId::_Template)
          , templateId (NULL)
    {
    }
};

class Cpp_UnqualifiedId_Identifier : public Cpp_UnqualifiedId
{
public:
    Cpp_Identifier *identifier;

    Cpp_UnqualifiedId_Identifier ()
        : Cpp_UnqualifiedId (Cpp_UnqualifiedId::_Identifier)
          , identifier (NULL)
    {
    }
};

void dump_cpp_UnqualifiedId (Cpp_UnqualifiedId const *, MyCpp::Size nest_level = 0);

bool cpp_accept_qualified_id_nested_name (
        Cpp_QualifiedId *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_QualifiedId : public CppElement
{
public:
    enum Type {
        _NestedNameSpecifier,
        _Identifier,
        _OperatorFunction,
        _Template
    };

    const Type qualified_id_type;

    Cpp_QualifiedId (Type type)
        : CppElement (CppElement::_QualifiedId),
          qualified_id_type (type)
    {
    }
};

bool cpp_accept_qualified_id_nested_name (
        Cpp_QualifiedId *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_QualifiedId_NestedNameSpecifier : public Cpp_QualifiedId
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_UnqualifiedId *unqualifiedId;

    Cpp_QualifiedId_NestedNameSpecifier ()
        : Cpp_QualifiedId (Cpp_QualifiedId::_NestedNameSpecifier)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , unqualifiedId (NULL)
    {
    }
};

class Cpp_QualifiedId_Identifier : public Cpp_QualifiedId
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_Identifier *identifier;

    Cpp_QualifiedId_Identifier ()
        : Cpp_QualifiedId (Cpp_QualifiedId::_Identifier)
          , scruffy_GlobalScope (NULL)
          , identifier (NULL)
    {
    }
};

class Cpp_QualifiedId_OperatorFunction : public Cpp_QualifiedId
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_OperatorFunctionId *operatorFunctionId;

    Cpp_QualifiedId_OperatorFunction ()
        : Cpp_QualifiedId (Cpp_QualifiedId::_OperatorFunction)
          , scruffy_GlobalScope (NULL)
          , operatorFunctionId (NULL)
    {
    }
};

class Cpp_QualifiedId_Template : public Cpp_QualifiedId
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_TemplateId *templateId;

    Cpp_QualifiedId_Template ()
        : Cpp_QualifiedId (Cpp_QualifiedId::_Template)
          , scruffy_GlobalScope (NULL)
          , templateId (NULL)
    {
    }
};

void dump_cpp_QualifiedId (Cpp_QualifiedId const *, MyCpp::Size nest_level = 0);

bool cpp_NestedNameSpecifier_ClassOrNamespaceName_accept_func (
        Cpp_NestedNameSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_NestedNameSpecifier : public CppElement
{
public:
    enum Type {
        _Template,
        _Generic
    };

    const Type nested_name_specifier_type;

    Cpp_NestedNameSpecifier (Type type)
        : CppElement (CppElement::_NestedNameSpecifier),
          nested_name_specifier_type (type)
    {
    }
};

bool cpp_NestedNameSpecifier_ClassOrNamespaceName_accept_func (
        Cpp_NestedNameSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_NestedNameSpecifier_Template : public Cpp_NestedNameSpecifier
{
public:
    Cpp_ClassOrNamespaceName *classOrNamespaceName;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;

    Cpp_NestedNameSpecifier_Template ()
        : Cpp_NestedNameSpecifier (Cpp_NestedNameSpecifier::_Template)
          , classOrNamespaceName (NULL)
          , nestedNameSpecifier (NULL)
    {
    }
};

class Cpp_NestedNameSpecifier_Generic : public Cpp_NestedNameSpecifier
{
public:
    Cpp_ClassOrNamespaceName *classOrNamespaceName;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;

    Cpp_NestedNameSpecifier_Generic ()
        : Cpp_NestedNameSpecifier (Cpp_NestedNameSpecifier::_Generic)
          , classOrNamespaceName (NULL)
          , nestedNameSpecifier (NULL)
    {
    }
};

void dump_cpp_NestedNameSpecifier (Cpp_NestedNameSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_ClassOrNamespaceName : public CppElement
{
public:
    enum Type {
        _ClassName,
        _NamespaceName
    };

    const Type class_or_namespace_name_type;

    Cpp_ClassOrNamespaceName (Type type)
        : CppElement (CppElement::_ClassOrNamespaceName),
          class_or_namespace_name_type (type)
    {
    }
};

class Cpp_ClassOrNamespaceName_ClassName : public Cpp_ClassOrNamespaceName
{
public:
    Cpp_ClassName *className;

    Cpp_ClassOrNamespaceName_ClassName ()
        : Cpp_ClassOrNamespaceName (Cpp_ClassOrNamespaceName::_ClassName)
          , className (NULL)
    {
    }
};

class Cpp_ClassOrNamespaceName_NamespaceName : public Cpp_ClassOrNamespaceName
{
public:
    Cpp_NamespaceName *namespaceName;

    Cpp_ClassOrNamespaceName_NamespaceName ()
        : Cpp_ClassOrNamespaceName (Cpp_ClassOrNamespaceName::_NamespaceName)
          , namespaceName (NULL)
    {
    }
};

void dump_cpp_ClassOrNamespaceName (Cpp_ClassOrNamespaceName const *, MyCpp::Size nest_level = 0);

bool cpp_begin_expression (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_postfix_expression (
        Cpp_PostfixExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_PostfixExpression : public CppElement
{
public:
    enum Type {
        _Subscripting,
        _FunctionCall,
        _TypeConversion,
        _TypenameTypeConversion,
        _TemplateTypeConversion,
        _DotMemberAccess,
        _ArrowMemberAccess,
        _DotPseudoDestructorCall,
        _ArrowPseudoDestructorCall,
        _PostfixIncrement,
        _PostfixDecrement,
        _DynamicCast,
        _StaticCast,
        _ReinterpretCast,
        _ConstCast,
        _TypeidTypeid,
        _TypeidExpression,
        _Expression
    };

    const Type postfix_expression_type;

    Cpp_PostfixExpression (Type type)
        : CppElement (CppElement::_PostfixExpression),
          postfix_expression_type (type)
    {
    }
};

bool cpp_begin_expression (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_postfix_expression (
        Cpp_PostfixExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_PostfixExpression_Subscripting : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;
    Cpp_Expression *expression;

    Cpp_PostfixExpression_Subscripting ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_Subscripting)
          , postfixExpression (NULL)
          , expression (NULL)
    {
    }
};

class Cpp_PostfixExpression_FunctionCall : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;
    Cpp_ExpressionList *expressionList;

    Cpp_PostfixExpression_FunctionCall ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_FunctionCall)
          , postfixExpression (NULL)
          , expressionList (NULL)
    {
    }
};

bool cpp_begin_declaration (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_PostfixExpression_TypeConversion : public Cpp_PostfixExpression
{
public:
    Cpp_SimpleTypeSpecifier *simpleTypeSpecifier;
    Cpp_ExpressionList *expressionList;

    Cpp_PostfixExpression_TypeConversion ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_TypeConversion)
          , simpleTypeSpecifier (NULL)
          , expressionList (NULL)
    {
    }
};

class Cpp_PostfixExpression_TypenameTypeConversion : public Cpp_PostfixExpression
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_Identifier *identifier;
    Cpp_ExpressionList *expressionList;

    Cpp_PostfixExpression_TypenameTypeConversion ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_TypenameTypeConversion)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , identifier (NULL)
          , expressionList (NULL)
    {
    }
};

class Cpp_PostfixExpression_TemplateTypeConversion : public Cpp_PostfixExpression
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TemplateId *templateId;
    Cpp_ExpressionList *expressionList;

    Cpp_PostfixExpression_TemplateTypeConversion ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_TemplateTypeConversion)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , templateId (NULL)
          , expressionList (NULL)
    {
    }
};

class Cpp_PostfixExpression_DotMemberAccess : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;
    Cpp_IdExpression *idExpression;

    Cpp_PostfixExpression_DotMemberAccess ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_DotMemberAccess)
          , postfixExpression (NULL)
          , idExpression (NULL)
    {
    }
};

class Cpp_PostfixExpression_ArrowMemberAccess : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;
    Cpp_IdExpression *idExpression;

    Cpp_PostfixExpression_ArrowMemberAccess ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_ArrowMemberAccess)
          , postfixExpression (NULL)
          , idExpression (NULL)
    {
    }
};

class Cpp_PostfixExpression_DotPseudoDestructorCall : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;
    Cpp_PseudoDestructorName *pseudoDestructorName;

    Cpp_PostfixExpression_DotPseudoDestructorCall ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_DotPseudoDestructorCall)
          , postfixExpression (NULL)
          , pseudoDestructorName (NULL)
    {
    }
};

class Cpp_PostfixExpression_ArrowPseudoDestructorCall : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;
    Cpp_PseudoDestructorName *pseudoDestructorName;

    Cpp_PostfixExpression_ArrowPseudoDestructorCall ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_ArrowPseudoDestructorCall)
          , postfixExpression (NULL)
          , pseudoDestructorName (NULL)
    {
    }
};

class Cpp_PostfixExpression_PostfixIncrement : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;

    Cpp_PostfixExpression_PostfixIncrement ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_PostfixIncrement)
          , postfixExpression (NULL)
    {
    }
};

class Cpp_PostfixExpression_PostfixDecrement : public Cpp_PostfixExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;

    Cpp_PostfixExpression_PostfixDecrement ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_PostfixDecrement)
          , postfixExpression (NULL)
    {
    }
};

bool cpp_begin_typeid (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_PostfixExpression_DynamicCast : public Cpp_PostfixExpression
{
public:
    Cpp_TypeId *typeId;
    Cpp_Expression *expression;

    Cpp_PostfixExpression_DynamicCast ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_DynamicCast)
          , typeId (NULL)
          , expression (NULL)
    {
    }
};

class Cpp_PostfixExpression_StaticCast : public Cpp_PostfixExpression
{
public:
    Cpp_TypeId *typeId;
    Cpp_Expression *expression;

    Cpp_PostfixExpression_StaticCast ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_StaticCast)
          , typeId (NULL)
          , expression (NULL)
    {
    }
};

class Cpp_PostfixExpression_ReinterpretCast : public Cpp_PostfixExpression
{
public:
    Cpp_TypeId *typeId;
    Cpp_Expression *expression;

    Cpp_PostfixExpression_ReinterpretCast ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_ReinterpretCast)
          , typeId (NULL)
          , expression (NULL)
    {
    }
};

class Cpp_PostfixExpression_ConstCast : public Cpp_PostfixExpression
{
public:
    Cpp_TypeId *typeId;
    Cpp_Expression *expression;

    Cpp_PostfixExpression_ConstCast ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_ConstCast)
          , typeId (NULL)
          , expression (NULL)
    {
    }
};

class Cpp_PostfixExpression_TypeidTypeid : public Cpp_PostfixExpression
{
public:
    Cpp_TypeId *typeId;

    Cpp_PostfixExpression_TypeidTypeid ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_TypeidTypeid)
          , typeId (NULL)
    {
    }
};

class Cpp_PostfixExpression_TypeidExpression : public Cpp_PostfixExpression
{
public:
    Cpp_Expression *expression;

    Cpp_PostfixExpression_TypeidExpression ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_TypeidExpression)
          , expression (NULL)
    {
    }
};

class Cpp_PostfixExpression_Expression : public Cpp_PostfixExpression
{
public:
    Cpp_PrimaryExpression *primaryExpression;

    Cpp_PostfixExpression_Expression ()
        : Cpp_PostfixExpression (Cpp_PostfixExpression::_Expression)
          , primaryExpression (NULL)
    {
    }
};

void dump_cpp_PostfixExpression (Cpp_PostfixExpression const *, MyCpp::Size nest_level = 0);

class Cpp_ExpressionList : public CppElement
{
public:
    enum Type {
        _ExpressionList,
        _Expression
    };

    const Type expression_list_type;

    Cpp_ExpressionList (Type type)
        : CppElement (CppElement::_ExpressionList),
          expression_list_type (type)
    {
    }
};

class Cpp_ExpressionList_ExpressionList : public Cpp_ExpressionList
{
public:
    Cpp_AssignmentExpression *assignmentExpression;
    Cpp_ExpressionList *expressionList;

    Cpp_ExpressionList_ExpressionList ()
        : Cpp_ExpressionList (Cpp_ExpressionList::_ExpressionList)
          , assignmentExpression (NULL)
          , expressionList (NULL)
    {
    }
};

class Cpp_ExpressionList_Expression : public Cpp_ExpressionList
{
public:
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_ExpressionList_Expression ()
        : Cpp_ExpressionList (Cpp_ExpressionList::_Expression)
          , assignmentExpression (NULL)
    {
    }
};

void dump_cpp_ExpressionList (Cpp_ExpressionList const *, MyCpp::Size nest_level = 0);

class Cpp_PseudoDestructorName : public CppElement
{
public:
    enum Type {
        _TypeName,
        _Template,
        _Basic
    };

    const Type pseudo_destructor_name_type;

    Cpp_PseudoDestructorName (Type type)
        : CppElement (CppElement::_PseudoDestructorName),
          pseudo_destructor_name_type (type)
    {
    }
};

class Cpp_PseudoDestructorName_TypeName : public Cpp_PseudoDestructorName
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TypeName *typeName;
    Cpp_TypeName *destructorTypeName;

    Cpp_PseudoDestructorName_TypeName ()
        : Cpp_PseudoDestructorName (Cpp_PseudoDestructorName::_TypeName)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , typeName (NULL)
          , destructorTypeName (NULL)
    {
    }
};

class Cpp_PseudoDestructorName_Template : public Cpp_PseudoDestructorName
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TemplateId *templateId;
    Cpp_TypeName *typeName;

    Cpp_PseudoDestructorName_Template ()
        : Cpp_PseudoDestructorName (Cpp_PseudoDestructorName::_Template)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , templateId (NULL)
          , typeName (NULL)
    {
    }
};

class Cpp_PseudoDestructorName_Basic : public Cpp_PseudoDestructorName
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TypeName *typeName;

    Cpp_PseudoDestructorName_Basic ()
        : Cpp_PseudoDestructorName (Cpp_PseudoDestructorName::_Basic)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , typeName (NULL)
    {
    }
};

void dump_cpp_PseudoDestructorName (Cpp_PseudoDestructorName const *, MyCpp::Size nest_level = 0);

bool cpp_accept_unary_expression (
        Cpp_UnaryExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_UnaryExpression : public CppElement
{
public:
    enum Type {
        _PrefixIncrement,
        _PrefixDecrement,
        _UnaryOperator,
        _SizeofExpression,
        _SizeofTypeid,
        _NewExpression,
        _DeleteExpression,
        _Expression
    };

    const Type unary_expression_type;

    Cpp_UnaryExpression (Type type)
        : CppElement (CppElement::_UnaryExpression),
          unary_expression_type (type)
    {
    }
};

bool cpp_accept_unary_expression (
        Cpp_UnaryExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_UnaryExpression_PrefixIncrement : public Cpp_UnaryExpression
{
public:
    Cpp_CastExpression *castExpression;

    Cpp_UnaryExpression_PrefixIncrement ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_PrefixIncrement)
          , castExpression (NULL)
    {
    }
};

class Cpp_UnaryExpression_PrefixDecrement : public Cpp_UnaryExpression
{
public:
    Cpp_CastExpression *castExpression;

    Cpp_UnaryExpression_PrefixDecrement ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_PrefixDecrement)
          , castExpression (NULL)
    {
    }
};

class Cpp_UnaryExpression_UnaryOperator : public Cpp_UnaryExpression
{
public:
    Cpp_UnaryOperator *unaryOperator;
    Cpp_CastExpression *castExpression;

    Cpp_UnaryExpression_UnaryOperator ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_UnaryOperator)
          , unaryOperator (NULL)
          , castExpression (NULL)
    {
    }
};

class Cpp_UnaryExpression_SizeofExpression : public Cpp_UnaryExpression
{
public:
    Cpp_UnaryExpression *unaryExpression;

    Cpp_UnaryExpression_SizeofExpression ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_SizeofExpression)
          , unaryExpression (NULL)
    {
    }
};

class Cpp_UnaryExpression_SizeofTypeid : public Cpp_UnaryExpression
{
public:
    Cpp_TypeId *typeId;

    Cpp_UnaryExpression_SizeofTypeid ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_SizeofTypeid)
          , typeId (NULL)
    {
    }
};

class Cpp_UnaryExpression_NewExpression : public Cpp_UnaryExpression
{
public:
    Cpp_NewExpression *newExpression;

    Cpp_UnaryExpression_NewExpression ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_NewExpression)
          , newExpression (NULL)
    {
    }
};

class Cpp_UnaryExpression_DeleteExpression : public Cpp_UnaryExpression
{
public:
    Cpp_DeleteExpression *deleteExpression;

    Cpp_UnaryExpression_DeleteExpression ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_DeleteExpression)
          , deleteExpression (NULL)
    {
    }
};

class Cpp_UnaryExpression_Expression : public Cpp_UnaryExpression
{
public:
    Cpp_PostfixExpression *postfixExpression;

    Cpp_UnaryExpression_Expression ()
        : Cpp_UnaryExpression (Cpp_UnaryExpression::_Expression)
          , postfixExpression (NULL)
    {
    }
};

void dump_cpp_UnaryExpression (Cpp_UnaryExpression const *, MyCpp::Size nest_level = 0);

class Cpp_UnaryOperator : public CppElement
{
public:
    enum Type {
        _Indirection,
        _PointerTo,
        _UnaryPlus,
        _UnaryMinus,
        _LogicalNegation,
        _OnesComplement
    };

    const Type unary_operator_type;

    Cpp_UnaryOperator (Type type)
        : CppElement (CppElement::_UnaryOperator),
          unary_operator_type (type)
    {
    }
};

class Cpp_UnaryOperator_Indirection : public Cpp_UnaryOperator
{
public:

    Cpp_UnaryOperator_Indirection ()
        : Cpp_UnaryOperator (Cpp_UnaryOperator::_Indirection)
    {
    }
};

class Cpp_UnaryOperator_PointerTo : public Cpp_UnaryOperator
{
public:

    Cpp_UnaryOperator_PointerTo ()
        : Cpp_UnaryOperator (Cpp_UnaryOperator::_PointerTo)
    {
    }
};

class Cpp_UnaryOperator_UnaryPlus : public Cpp_UnaryOperator
{
public:

    Cpp_UnaryOperator_UnaryPlus ()
        : Cpp_UnaryOperator (Cpp_UnaryOperator::_UnaryPlus)
    {
    }
};

class Cpp_UnaryOperator_UnaryMinus : public Cpp_UnaryOperator
{
public:

    Cpp_UnaryOperator_UnaryMinus ()
        : Cpp_UnaryOperator (Cpp_UnaryOperator::_UnaryMinus)
    {
    }
};

class Cpp_UnaryOperator_LogicalNegation : public Cpp_UnaryOperator
{
public:

    Cpp_UnaryOperator_LogicalNegation ()
        : Cpp_UnaryOperator (Cpp_UnaryOperator::_LogicalNegation)
    {
    }
};

class Cpp_UnaryOperator_OnesComplement : public Cpp_UnaryOperator
{
public:

    Cpp_UnaryOperator_OnesComplement ()
        : Cpp_UnaryOperator (Cpp_UnaryOperator::_OnesComplement)
    {
    }
};

void dump_cpp_UnaryOperator (Cpp_UnaryOperator const *, MyCpp::Size nest_level = 0);

class Cpp_NewExpression : public CppElement
{
public:
    enum Type {
        _Basic,
        _Braces
    };

    const Type new_expression_type;

    Cpp_NewExpression (Type type)
        : CppElement (CppElement::_NewExpression),
          new_expression_type (type)
    {
    }
};

class Cpp_NewExpression_Basic : public Cpp_NewExpression
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NewPlacement *newPlacement;
    Cpp_NewTypeId *newTypeId;
    Cpp_NewInitializer *newInitializer;

    Cpp_NewExpression_Basic ()
        : Cpp_NewExpression (Cpp_NewExpression::_Basic)
          , scruffy_GlobalScope (NULL)
          , newPlacement (NULL)
          , newTypeId (NULL)
          , newInitializer (NULL)
    {
    }
};

class Cpp_NewExpression_Braces : public Cpp_NewExpression
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NewPlacement *newPlacement;
    Cpp_TypeId *typeId;
    Cpp_NewInitializer *newInitializer;

    Cpp_NewExpression_Braces ()
        : Cpp_NewExpression (Cpp_NewExpression::_Braces)
          , scruffy_GlobalScope (NULL)
          , newPlacement (NULL)
          , typeId (NULL)
          , newInitializer (NULL)
    {
    }
};

void dump_cpp_NewExpression (Cpp_NewExpression const *, MyCpp::Size nest_level = 0);

class Cpp_NewPlacement : public CppElement
{
public:
    Cpp_ExpressionList *expressionList;

    Cpp_NewPlacement ()
        : CppElement (CppElement::_NewPlacement)
          , expressionList (NULL)
    {
    }
};

void dump_cpp_NewPlacement (Cpp_NewPlacement const *, MyCpp::Size nest_level = 0);

class Cpp_NewTypeId : public CppElement
{
public:
    Cpp_TypeSpecifierSeq *typeSpecifierSeq;
    Cpp_NewDeclarator *newDeclarator;

    Cpp_NewTypeId ()
        : CppElement (CppElement::_NewTypeId)
          , typeSpecifierSeq (NULL)
          , newDeclarator (NULL)
    {
    }
};

void dump_cpp_NewTypeId (Cpp_NewTypeId const *, MyCpp::Size nest_level = 0);

class Cpp_NewDeclarator : public CppElement
{
public:
    enum Type {
        _PtrOperator,
        _DirectNewDeclarator
    };

    const Type new_declarator_type;

    Cpp_NewDeclarator (Type type)
        : CppElement (CppElement::_NewDeclarator),
          new_declarator_type (type)
    {
    }
};

class Cpp_NewDeclarator_PtrOperator : public Cpp_NewDeclarator
{
public:
    Cpp_PtrOperator *ptrOperator;
    Cpp_NewDeclarator *newDeclarator;

    Cpp_NewDeclarator_PtrOperator ()
        : Cpp_NewDeclarator (Cpp_NewDeclarator::_PtrOperator)
          , ptrOperator (NULL)
          , newDeclarator (NULL)
    {
    }
};

class Cpp_NewDeclarator_DirectNewDeclarator : public Cpp_NewDeclarator
{
public:
    Cpp_DirectNewDeclarator *directNewDeclarator;

    Cpp_NewDeclarator_DirectNewDeclarator ()
        : Cpp_NewDeclarator (Cpp_NewDeclarator::_DirectNewDeclarator)
          , directNewDeclarator (NULL)
    {
    }
};

void dump_cpp_NewDeclarator (Cpp_NewDeclarator const *, MyCpp::Size nest_level = 0);

class Cpp_DirectNewDeclarator : public CppElement
{
public:
    enum Type {
        _Expression,
        _DirectNewDeclarator
    };

    const Type direct_new_declarator_type;

    Cpp_DirectNewDeclarator (Type type)
        : CppElement (CppElement::_DirectNewDeclarator),
          direct_new_declarator_type (type)
    {
    }
};

class Cpp_DirectNewDeclarator_Expression : public Cpp_DirectNewDeclarator
{
public:
    Cpp_Expression *expression;

    Cpp_DirectNewDeclarator_Expression ()
        : Cpp_DirectNewDeclarator (Cpp_DirectNewDeclarator::_Expression)
          , expression (NULL)
    {
    }
};

class Cpp_DirectNewDeclarator_DirectNewDeclarator : public Cpp_DirectNewDeclarator
{
public:
    Cpp_DirectNewDeclarator *directNewDeclarator;
    Cpp_ConstantExpression *constantExpression;

    Cpp_DirectNewDeclarator_DirectNewDeclarator ()
        : Cpp_DirectNewDeclarator (Cpp_DirectNewDeclarator::_DirectNewDeclarator)
          , directNewDeclarator (NULL)
          , constantExpression (NULL)
    {
    }
};

void dump_cpp_DirectNewDeclarator (Cpp_DirectNewDeclarator const *, MyCpp::Size nest_level = 0);

class Cpp_NewInitializer : public CppElement
{
public:
    Cpp_ExpressionList *expressionList;

    Cpp_NewInitializer ()
        : CppElement (CppElement::_NewInitializer)
          , expressionList (NULL)
    {
    }
};

void dump_cpp_NewInitializer (Cpp_NewInitializer const *, MyCpp::Size nest_level = 0);

class Cpp_DeleteExpression : public CppElement
{
public:
    enum Type {
        _Delete,
        _DeleteArray
    };

    const Type delete_expression_type;

    Cpp_DeleteExpression (Type type)
        : CppElement (CppElement::_DeleteExpression),
          delete_expression_type (type)
    {
    }
};

class Cpp_DeleteExpression_Delete : public Cpp_DeleteExpression
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_CastExpression *castExpression;

    Cpp_DeleteExpression_Delete ()
        : Cpp_DeleteExpression (Cpp_DeleteExpression::_Delete)
          , scruffy_GlobalScope (NULL)
          , castExpression (NULL)
    {
    }
};

class Cpp_DeleteExpression_DeleteArray : public Cpp_DeleteExpression
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_CastExpression *castExpression;

    Cpp_DeleteExpression_DeleteArray ()
        : Cpp_DeleteExpression (Cpp_DeleteExpression::_DeleteArray)
          , scruffy_GlobalScope (NULL)
          , castExpression (NULL)
    {
    }
};

void dump_cpp_DeleteExpression (Cpp_DeleteExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_cast_expression (
        Cpp_CastExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_CastExpression : public CppElement
{
public:
    enum Type {
        _Cast,
        _Expression
    };

    const Type cast_expression_type;

    Cpp_CastExpression (Type type)
        : CppElement (CppElement::_CastExpression),
          cast_expression_type (type)
    {
    }
};

bool cpp_accept_cast_expression (
        Cpp_CastExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_CastExpression_Cast : public Cpp_CastExpression
{
public:
    Cpp_TypeId *typeId;
    Cpp_CastExpression *castExpression;

    Cpp_CastExpression_Cast ()
        : Cpp_CastExpression (Cpp_CastExpression::_Cast)
          , typeId (NULL)
          , castExpression (NULL)
    {
    }
};

class Cpp_CastExpression_Expression : public Cpp_CastExpression
{
public:
    Cpp_UnaryExpression *unaryExpression;

    Cpp_CastExpression_Expression ()
        : Cpp_CastExpression (Cpp_CastExpression::_Expression)
          , unaryExpression (NULL)
    {
    }
};

void dump_cpp_CastExpression (Cpp_CastExpression const *, MyCpp::Size nest_level = 0);

class Cpp_PmExpression : public CppElement
{
public:
    enum Type {
        _DotPm,
        _ArrowPm,
        _Expression
    };

    const Type pm_expression_type;

    Cpp_PmExpression (Type type)
        : CppElement (CppElement::_PmExpression),
          pm_expression_type (type)
    {
    }
};

class Cpp_PmExpression_DotPm : public Cpp_PmExpression
{
public:
    Cpp_PmExpression *pmExpression;
    Cpp_CastExpression *castExpression;

    Cpp_PmExpression_DotPm ()
        : Cpp_PmExpression (Cpp_PmExpression::_DotPm)
          , pmExpression (NULL)
          , castExpression (NULL)
    {
    }
};

class Cpp_PmExpression_ArrowPm : public Cpp_PmExpression
{
public:
    Cpp_PmExpression *pmExpression;
    Cpp_CastExpression *castExpression;

    Cpp_PmExpression_ArrowPm ()
        : Cpp_PmExpression (Cpp_PmExpression::_ArrowPm)
          , pmExpression (NULL)
          , castExpression (NULL)
    {
    }
};

class Cpp_PmExpression_Expression : public Cpp_PmExpression
{
public:
    Cpp_CastExpression *castExpression;

    Cpp_PmExpression_Expression ()
        : Cpp_PmExpression (Cpp_PmExpression::_Expression)
          , castExpression (NULL)
    {
    }
};

void dump_cpp_PmExpression (Cpp_PmExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_multiplicative_expression (
        Cpp_MultiplicativeExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_MultiplicativeExpression : public CppElement
{
public:
    enum Type {
        _Multiplication,
        _Division,
        _Remainder,
        _Expression
    };

    const Type multiplicative_expression_type;

    Cpp_MultiplicativeExpression (Type type)
        : CppElement (CppElement::_MultiplicativeExpression),
          multiplicative_expression_type (type)
    {
    }
};

bool cpp_accept_multiplicative_expression (
        Cpp_MultiplicativeExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_MultiplicativeExpression_Multiplication : public Cpp_MultiplicativeExpression
{
public:
    Cpp_MultiplicativeExpression *multiplicativeExpression;
    Cpp_PmExpression *pmExpression;

    Cpp_MultiplicativeExpression_Multiplication ()
        : Cpp_MultiplicativeExpression (Cpp_MultiplicativeExpression::_Multiplication)
          , multiplicativeExpression (NULL)
          , pmExpression (NULL)
    {
    }
};

class Cpp_MultiplicativeExpression_Division : public Cpp_MultiplicativeExpression
{
public:
    Cpp_MultiplicativeExpression *multiplicativeExpression;
    Cpp_PmExpression *pmExpression;

    Cpp_MultiplicativeExpression_Division ()
        : Cpp_MultiplicativeExpression (Cpp_MultiplicativeExpression::_Division)
          , multiplicativeExpression (NULL)
          , pmExpression (NULL)
    {
    }
};

class Cpp_MultiplicativeExpression_Remainder : public Cpp_MultiplicativeExpression
{
public:
    Cpp_MultiplicativeExpression *multiplicativeExpression;
    Cpp_PmExpression *pmExpression;

    Cpp_MultiplicativeExpression_Remainder ()
        : Cpp_MultiplicativeExpression (Cpp_MultiplicativeExpression::_Remainder)
          , multiplicativeExpression (NULL)
          , pmExpression (NULL)
    {
    }
};

class Cpp_MultiplicativeExpression_Expression : public Cpp_MultiplicativeExpression
{
public:
    Cpp_PmExpression *pmExpression;

    Cpp_MultiplicativeExpression_Expression ()
        : Cpp_MultiplicativeExpression (Cpp_MultiplicativeExpression::_Expression)
          , pmExpression (NULL)
    {
    }
};

void dump_cpp_MultiplicativeExpression (Cpp_MultiplicativeExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_additive_expression (
        Cpp_AdditiveExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_AdditiveExpression : public CppElement
{
public:
    enum Type {
        _Addition,
        _Subtraction,
        _Expression
    };

    const Type additive_expression_type;

    Cpp_AdditiveExpression (Type type)
        : CppElement (CppElement::_AdditiveExpression),
          additive_expression_type (type)
    {
    }
};

bool cpp_accept_additive_expression (
        Cpp_AdditiveExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_AdditiveExpression_Addition : public Cpp_AdditiveExpression
{
public:
    Cpp_AdditiveExpression *additiveExpression;
    Cpp_MultiplicativeExpression *multiplicativeExpression;

    Cpp_AdditiveExpression_Addition ()
        : Cpp_AdditiveExpression (Cpp_AdditiveExpression::_Addition)
          , additiveExpression (NULL)
          , multiplicativeExpression (NULL)
    {
    }
};

class Cpp_AdditiveExpression_Subtraction : public Cpp_AdditiveExpression
{
public:
    Cpp_AdditiveExpression *additiveExpression;
    Cpp_MultiplicativeExpression *multiplicativeExpression;

    Cpp_AdditiveExpression_Subtraction ()
        : Cpp_AdditiveExpression (Cpp_AdditiveExpression::_Subtraction)
          , additiveExpression (NULL)
          , multiplicativeExpression (NULL)
    {
    }
};

class Cpp_AdditiveExpression_Expression : public Cpp_AdditiveExpression
{
public:
    Cpp_MultiplicativeExpression *multiplicativeExpression;

    Cpp_AdditiveExpression_Expression ()
        : Cpp_AdditiveExpression (Cpp_AdditiveExpression::_Expression)
          , multiplicativeExpression (NULL)
    {
    }
};

void dump_cpp_AdditiveExpression (Cpp_AdditiveExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_shift_expression (
        Cpp_ShiftExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ShiftExpression : public CppElement
{
public:
    enum Type {
        _LeftShift,
        _RightShift,
        _Expression
    };

    const Type shift_expression_type;

    Cpp_ShiftExpression (Type type)
        : CppElement (CppElement::_ShiftExpression),
          shift_expression_type (type)
    {
    }
};

bool cpp_accept_shift_expression (
        Cpp_ShiftExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ShiftExpression_LeftShift : public Cpp_ShiftExpression
{
public:
    Cpp_ShiftExpression *shiftExpression;
    Cpp_AdditiveExpression *additiveExpression;

    Cpp_ShiftExpression_LeftShift ()
        : Cpp_ShiftExpression (Cpp_ShiftExpression::_LeftShift)
          , shiftExpression (NULL)
          , additiveExpression (NULL)
    {
    }
};

class Cpp_ShiftExpression_RightShift : public Cpp_ShiftExpression
{
public:
    Cpp_ShiftExpression *shiftExpression;
    Cpp_AdditiveExpression *additiveExpression;

    Cpp_ShiftExpression_RightShift ()
        : Cpp_ShiftExpression (Cpp_ShiftExpression::_RightShift)
          , shiftExpression (NULL)
          , additiveExpression (NULL)
    {
    }
};

class Cpp_ShiftExpression_Expression : public Cpp_ShiftExpression
{
public:
    Cpp_AdditiveExpression *additiveExpression;

    Cpp_ShiftExpression_Expression ()
        : Cpp_ShiftExpression (Cpp_ShiftExpression::_Expression)
          , additiveExpression (NULL)
    {
    }
};

void dump_cpp_ShiftExpression (Cpp_ShiftExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_relational_expression (
        Cpp_RelationalExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_RelationalExpression : public CppElement
{
public:
    enum Type {
        _Less,
        _Greater,
        _LessOrEqual,
        _GreaterOrEqual,
        _Expression
    };

    const Type relational_expression_type;

    Cpp_RelationalExpression (Type type)
        : CppElement (CppElement::_RelationalExpression),
          relational_expression_type (type)
    {
    }
};

bool cpp_accept_relational_expression (
        Cpp_RelationalExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_RelationalExpression_Less : public Cpp_RelationalExpression
{
public:
    Cpp_RelationalExpression *relationalExpression;
    Cpp_ShiftExpression *shiftExpression;

    Cpp_RelationalExpression_Less ()
        : Cpp_RelationalExpression (Cpp_RelationalExpression::_Less)
          , relationalExpression (NULL)
          , shiftExpression (NULL)
    {
    }
};

class Cpp_RelationalExpression_Greater : public Cpp_RelationalExpression
{
public:
    Cpp_RelationalExpression *relationalExpression;
    Cpp_ShiftExpression *shiftExpression;

    Cpp_RelationalExpression_Greater ()
        : Cpp_RelationalExpression (Cpp_RelationalExpression::_Greater)
          , relationalExpression (NULL)
          , shiftExpression (NULL)
    {
    }
};

class Cpp_RelationalExpression_LessOrEqual : public Cpp_RelationalExpression
{
public:
    Cpp_RelationalExpression *relationalExpression;
    Cpp_ShiftExpression *shiftExpression;

    Cpp_RelationalExpression_LessOrEqual ()
        : Cpp_RelationalExpression (Cpp_RelationalExpression::_LessOrEqual)
          , relationalExpression (NULL)
          , shiftExpression (NULL)
    {
    }
};

class Cpp_RelationalExpression_GreaterOrEqual : public Cpp_RelationalExpression
{
public:
    Cpp_RelationalExpression *relationalExpression;
    Cpp_ShiftExpression *shiftExpression;

    Cpp_RelationalExpression_GreaterOrEqual ()
        : Cpp_RelationalExpression (Cpp_RelationalExpression::_GreaterOrEqual)
          , relationalExpression (NULL)
          , shiftExpression (NULL)
    {
    }
};

class Cpp_RelationalExpression_Expression : public Cpp_RelationalExpression
{
public:
    Cpp_ShiftExpression *shiftExpression;

    Cpp_RelationalExpression_Expression ()
        : Cpp_RelationalExpression (Cpp_RelationalExpression::_Expression)
          , shiftExpression (NULL)
    {
    }
};

void dump_cpp_RelationalExpression (Cpp_RelationalExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_equality_expression (
        Cpp_EqualityExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_EqualityExpression : public CppElement
{
public:
    enum Type {
        _Equal,
        _NotEqual,
        _Expression
    };

    const Type equality_expression_type;

    Cpp_EqualityExpression (Type type)
        : CppElement (CppElement::_EqualityExpression),
          equality_expression_type (type)
    {
    }
};

bool cpp_accept_equality_expression (
        Cpp_EqualityExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_EqualityExpression_Equal : public Cpp_EqualityExpression
{
public:
    Cpp_EqualityExpression *equalityExpression;
    Cpp_RelationalExpression *relationalExpression;

    Cpp_EqualityExpression_Equal ()
        : Cpp_EqualityExpression (Cpp_EqualityExpression::_Equal)
          , equalityExpression (NULL)
          , relationalExpression (NULL)
    {
    }
};

class Cpp_EqualityExpression_NotEqual : public Cpp_EqualityExpression
{
public:
    Cpp_EqualityExpression *equalityExpression;
    Cpp_RelationalExpression *relationalExpression;

    Cpp_EqualityExpression_NotEqual ()
        : Cpp_EqualityExpression (Cpp_EqualityExpression::_NotEqual)
          , equalityExpression (NULL)
          , relationalExpression (NULL)
    {
    }
};

class Cpp_EqualityExpression_Expression : public Cpp_EqualityExpression
{
public:
    Cpp_RelationalExpression *relationalExpression;

    Cpp_EqualityExpression_Expression ()
        : Cpp_EqualityExpression (Cpp_EqualityExpression::_Expression)
          , relationalExpression (NULL)
    {
    }
};

void dump_cpp_EqualityExpression (Cpp_EqualityExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_and_expression (
        Cpp_AndExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_AndExpression : public CppElement
{
public:
    enum Type {
        _BitwiseAnd,
        _Expression
    };

    const Type and_expression_type;

    Cpp_AndExpression (Type type)
        : CppElement (CppElement::_AndExpression),
          and_expression_type (type)
    {
    }
};

bool cpp_accept_and_expression (
        Cpp_AndExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_AndExpression_BitwiseAnd : public Cpp_AndExpression
{
public:
    Cpp_AndExpression *andExpression;
    Cpp_EqualityExpression *equalityExpression;

    Cpp_AndExpression_BitwiseAnd ()
        : Cpp_AndExpression (Cpp_AndExpression::_BitwiseAnd)
          , andExpression (NULL)
          , equalityExpression (NULL)
    {
    }
};

class Cpp_AndExpression_Expression : public Cpp_AndExpression
{
public:
    Cpp_EqualityExpression *equalityExpression;

    Cpp_AndExpression_Expression ()
        : Cpp_AndExpression (Cpp_AndExpression::_Expression)
          , equalityExpression (NULL)
    {
    }
};

void dump_cpp_AndExpression (Cpp_AndExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_exclusive_or_expression (
        Cpp_ExclusiveOrExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ExclusiveOrExpression : public CppElement
{
public:
    enum Type {
        _BitwiseExclusiveOr,
        _Expression
    };

    const Type exclusive_or_expression_type;

    Cpp_ExclusiveOrExpression (Type type)
        : CppElement (CppElement::_ExclusiveOrExpression),
          exclusive_or_expression_type (type)
    {
    }
};

bool cpp_accept_exclusive_or_expression (
        Cpp_ExclusiveOrExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ExclusiveOrExpression_BitwiseExclusiveOr : public Cpp_ExclusiveOrExpression
{
public:
    Cpp_ExclusiveOrExpression *exclusiveOrExpression;
    Cpp_AndExpression *andExpression;

    Cpp_ExclusiveOrExpression_BitwiseExclusiveOr ()
        : Cpp_ExclusiveOrExpression (Cpp_ExclusiveOrExpression::_BitwiseExclusiveOr)
          , exclusiveOrExpression (NULL)
          , andExpression (NULL)
    {
    }
};

class Cpp_ExclusiveOrExpression_Expression : public Cpp_ExclusiveOrExpression
{
public:
    Cpp_AndExpression *andExpression;

    Cpp_ExclusiveOrExpression_Expression ()
        : Cpp_ExclusiveOrExpression (Cpp_ExclusiveOrExpression::_Expression)
          , andExpression (NULL)
    {
    }
};

void dump_cpp_ExclusiveOrExpression (Cpp_ExclusiveOrExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_inclusive_or_expression (
        Cpp_InclusiveOrExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_InclusiveOrExpression : public CppElement
{
public:
    enum Type {
        _BitwiseInclusiveOr,
        _Expression
    };

    const Type inclusive_or_expression_type;

    Cpp_InclusiveOrExpression (Type type)
        : CppElement (CppElement::_InclusiveOrExpression),
          inclusive_or_expression_type (type)
    {
    }
};

bool cpp_accept_inclusive_or_expression (
        Cpp_InclusiveOrExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_InclusiveOrExpression_BitwiseInclusiveOr : public Cpp_InclusiveOrExpression
{
public:
    Cpp_InclusiveOrExpression *inclusiveOrExpression;
    Cpp_ExclusiveOrExpression *exclusiveOrExpression;

    Cpp_InclusiveOrExpression_BitwiseInclusiveOr ()
        : Cpp_InclusiveOrExpression (Cpp_InclusiveOrExpression::_BitwiseInclusiveOr)
          , inclusiveOrExpression (NULL)
          , exclusiveOrExpression (NULL)
    {
    }
};

class Cpp_InclusiveOrExpression_Expression : public Cpp_InclusiveOrExpression
{
public:
    Cpp_ExclusiveOrExpression *exclusiveOrExpression;

    Cpp_InclusiveOrExpression_Expression ()
        : Cpp_InclusiveOrExpression (Cpp_InclusiveOrExpression::_Expression)
          , exclusiveOrExpression (NULL)
    {
    }
};

void dump_cpp_InclusiveOrExpression (Cpp_InclusiveOrExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_logical_and_expression (
        Cpp_LogicalAndExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_LogicalAndExpression : public CppElement
{
public:
    enum Type {
        _LogicalAnd,
        _Expression
    };

    const Type logical_and_expression_type;

    Cpp_LogicalAndExpression (Type type)
        : CppElement (CppElement::_LogicalAndExpression),
          logical_and_expression_type (type)
    {
    }
};

bool cpp_accept_logical_and_expression (
        Cpp_LogicalAndExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_LogicalAndExpression_LogicalAnd : public Cpp_LogicalAndExpression
{
public:
    Cpp_LogicalAndExpression *logicalAndExpression;
    Cpp_InclusiveOrExpression *inclusiveOrExpression;

    Cpp_LogicalAndExpression_LogicalAnd ()
        : Cpp_LogicalAndExpression (Cpp_LogicalAndExpression::_LogicalAnd)
          , logicalAndExpression (NULL)
          , inclusiveOrExpression (NULL)
    {
    }
};

class Cpp_LogicalAndExpression_Expression : public Cpp_LogicalAndExpression
{
public:
    Cpp_InclusiveOrExpression *inclusiveOrExpression;

    Cpp_LogicalAndExpression_Expression ()
        : Cpp_LogicalAndExpression (Cpp_LogicalAndExpression::_Expression)
          , inclusiveOrExpression (NULL)
    {
    }
};

void dump_cpp_LogicalAndExpression (Cpp_LogicalAndExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_logical_or_expression (
        Cpp_LogicalOrExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_LogicalOrExpression : public CppElement
{
public:
    enum Type {
        _LogicalOr,
        _Expression
    };

    const Type logical_or_expression_type;

    Cpp_LogicalOrExpression (Type type)
        : CppElement (CppElement::_LogicalOrExpression),
          logical_or_expression_type (type)
    {
    }
};

bool cpp_accept_logical_or_expression (
        Cpp_LogicalOrExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_LogicalOrExpression_LogicalOr : public Cpp_LogicalOrExpression
{
public:
    Cpp_LogicalOrExpression *logicalOrExpression;
    Cpp_LogicalAndExpression *logicalAndExpression;

    Cpp_LogicalOrExpression_LogicalOr ()
        : Cpp_LogicalOrExpression (Cpp_LogicalOrExpression::_LogicalOr)
          , logicalOrExpression (NULL)
          , logicalAndExpression (NULL)
    {
    }
};

class Cpp_LogicalOrExpression_Expression : public Cpp_LogicalOrExpression
{
public:
    Cpp_LogicalAndExpression *logicalAndExpression;

    Cpp_LogicalOrExpression_Expression ()
        : Cpp_LogicalOrExpression (Cpp_LogicalOrExpression::_Expression)
          , logicalAndExpression (NULL)
    {
    }
};

void dump_cpp_LogicalOrExpression (Cpp_LogicalOrExpression const *, MyCpp::Size nest_level = 0);

class Cpp_ConditionalExpression : public CppElement
{
public:
    enum Type {
        _Conditional,
        _Expression
    };

    const Type conditional_expression_type;

    Cpp_ConditionalExpression (Type type)
        : CppElement (CppElement::_ConditionalExpression),
          conditional_expression_type (type)
    {
    }
};

class Cpp_ConditionalExpression_Conditional : public Cpp_ConditionalExpression
{
public:
    Cpp_LogicalOrExpression *logicalOrExpression;
    Cpp_Expression *expression;
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_ConditionalExpression_Conditional ()
        : Cpp_ConditionalExpression (Cpp_ConditionalExpression::_Conditional)
          , logicalOrExpression (NULL)
          , expression (NULL)
          , assignmentExpression (NULL)
    {
    }
};

class Cpp_ConditionalExpression_Expression : public Cpp_ConditionalExpression
{
public:
    Cpp_LogicalOrExpression *logicalOrExpression;

    Cpp_ConditionalExpression_Expression ()
        : Cpp_ConditionalExpression (Cpp_ConditionalExpression::_Expression)
          , logicalOrExpression (NULL)
    {
    }
};

void dump_cpp_ConditionalExpression (Cpp_ConditionalExpression const *, MyCpp::Size nest_level = 0);

bool cpp_accept_assignment_expression (
        Cpp_AssignmentExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_AssignmentExpression : public CppElement
{
public:
    enum Type {
        _Assignment,
        _Throw,
        _Expression
    };

    const Type assignment_expression_type;

    Cpp_AssignmentExpression (Type type)
        : CppElement (CppElement::_AssignmentExpression),
          assignment_expression_type (type)
    {
    }
};

bool cpp_accept_assignment_expression (
        Cpp_AssignmentExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_AssignmentExpression_Assignment : public Cpp_AssignmentExpression
{
public:
    Cpp_LogicalOrExpression *logicalOrExpression;
    Cpp_AssignmentOperator *assignmentOperator;
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_AssignmentExpression_Assignment ()
        : Cpp_AssignmentExpression (Cpp_AssignmentExpression::_Assignment)
          , logicalOrExpression (NULL)
          , assignmentOperator (NULL)
          , assignmentExpression (NULL)
    {
    }
};

class Cpp_AssignmentExpression_Throw : public Cpp_AssignmentExpression
{
public:
    Cpp_ThrowExpression *throwExpression;

    Cpp_AssignmentExpression_Throw ()
        : Cpp_AssignmentExpression (Cpp_AssignmentExpression::_Throw)
          , throwExpression (NULL)
    {
    }
};

class Cpp_AssignmentExpression_Expression : public Cpp_AssignmentExpression
{
public:
    Cpp_ConditionalExpression *conditionalExpression;

    Cpp_AssignmentExpression_Expression ()
        : Cpp_AssignmentExpression (Cpp_AssignmentExpression::_Expression)
          , conditionalExpression (NULL)
    {
    }
};

void dump_cpp_AssignmentExpression (Cpp_AssignmentExpression const *, MyCpp::Size nest_level = 0);

class Cpp_AssignmentOperator : public CppElement
{
public:
    enum Type {
        _Generic,
        _Multiplication,
        _Division,
        _Remainder,
        _Addition,
        _Subtraction,
        _RightShift,
        _LeftShift,
        _BitwiseAnd,
        _BitwiseExclusiveOr,
        _BitwiseInclusiveOr
    };

    const Type assignment_operator_type;

    Cpp_AssignmentOperator (Type type)
        : CppElement (CppElement::_AssignmentOperator),
          assignment_operator_type (type)
    {
    }
};

class Cpp_AssignmentOperator_Generic : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_Generic ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_Generic)
    {
    }
};

class Cpp_AssignmentOperator_Multiplication : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_Multiplication ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_Multiplication)
    {
    }
};

class Cpp_AssignmentOperator_Division : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_Division ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_Division)
    {
    }
};

class Cpp_AssignmentOperator_Remainder : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_Remainder ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_Remainder)
    {
    }
};

class Cpp_AssignmentOperator_Addition : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_Addition ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_Addition)
    {
    }
};

class Cpp_AssignmentOperator_Subtraction : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_Subtraction ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_Subtraction)
    {
    }
};

class Cpp_AssignmentOperator_RightShift : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_RightShift ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_RightShift)
    {
    }
};

class Cpp_AssignmentOperator_LeftShift : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_LeftShift ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_LeftShift)
    {
    }
};

class Cpp_AssignmentOperator_BitwiseAnd : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_BitwiseAnd ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_BitwiseAnd)
    {
    }
};

class Cpp_AssignmentOperator_BitwiseExclusiveOr : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_BitwiseExclusiveOr ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_BitwiseExclusiveOr)
    {
    }
};

class Cpp_AssignmentOperator_BitwiseInclusiveOr : public Cpp_AssignmentOperator
{
public:

    Cpp_AssignmentOperator_BitwiseInclusiveOr ()
        : Cpp_AssignmentOperator (Cpp_AssignmentOperator::_BitwiseInclusiveOr)
    {
    }
};

void dump_cpp_AssignmentOperator (Cpp_AssignmentOperator const *, MyCpp::Size nest_level = 0);

bool cpp_accept_comma_expression (
        Cpp_Expression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_Expression : public CppElement
{
public:
    enum Type {
        _Comma,
        _Expression
    };

    const Type expression_type;

    Cpp_Expression (Type type)
        : CppElement (CppElement::_Expression),
          expression_type (type)
    {
    }
};

bool cpp_accept_comma_expression (
        Cpp_Expression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_Expression_Comma : public Cpp_Expression
{
public:
    Cpp_Expression *expression;
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_Expression_Comma ()
        : Cpp_Expression (Cpp_Expression::_Comma)
          , expression (NULL)
          , assignmentExpression (NULL)
    {
    }
};

class Cpp_Expression_Expression : public Cpp_Expression
{
public:
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_Expression_Expression ()
        : Cpp_Expression (Cpp_Expression::_Expression)
          , assignmentExpression (NULL)
    {
    }
};

void dump_cpp_Expression (Cpp_Expression const *, MyCpp::Size nest_level = 0);

class Cpp_ConstantExpression : public CppElement
{
public:
    Cpp_ConditionalExpression *conditionalExpression;

    Cpp_ConstantExpression ()
        : CppElement (CppElement::_ConstantExpression)
          , conditionalExpression (NULL)
    {
    }
};

void dump_cpp_ConstantExpression (Cpp_ConstantExpression const *, MyCpp::Size nest_level = 0);

class Cpp_Statement : public CppElement
{
public:
    enum Type {
        _LabeledStatement,
        _DeclarationStatement,
        _ExpressionStatement,
        _CompoundStatement,
        _SelectionStatement,
        _IterationStatement,
        _JumpStatement,
        _TryBlock
    };

    const Type statement_type;

    Cpp_Statement (Type type)
        : CppElement (CppElement::_Statement),
          statement_type (type)
    {
    }
};

class Cpp_Statement_LabeledStatement : public Cpp_Statement
{
public:
    Cpp_LabeledStatement *labeledStatement;

    Cpp_Statement_LabeledStatement ()
        : Cpp_Statement (Cpp_Statement::_LabeledStatement)
          , labeledStatement (NULL)
    {
    }
};

class Cpp_Statement_DeclarationStatement : public Cpp_Statement
{
public:
    Cpp_DeclarationStatement *declarationStatement;

    Cpp_Statement_DeclarationStatement ()
        : Cpp_Statement (Cpp_Statement::_DeclarationStatement)
          , declarationStatement (NULL)
    {
    }
};

class Cpp_Statement_ExpressionStatement : public Cpp_Statement
{
public:
    Cpp_ExpressionStatement *expressionStatement;

    Cpp_Statement_ExpressionStatement ()
        : Cpp_Statement (Cpp_Statement::_ExpressionStatement)
          , expressionStatement (NULL)
    {
    }
};

class Cpp_Statement_CompoundStatement : public Cpp_Statement
{
public:
    Cpp_CompoundStatement *compoundStatement;

    Cpp_Statement_CompoundStatement ()
        : Cpp_Statement (Cpp_Statement::_CompoundStatement)
          , compoundStatement (NULL)
    {
    }
};

class Cpp_Statement_SelectionStatement : public Cpp_Statement
{
public:
    Cpp_SelectionStatement *selectionStatement;

    Cpp_Statement_SelectionStatement ()
        : Cpp_Statement (Cpp_Statement::_SelectionStatement)
          , selectionStatement (NULL)
    {
    }
};

class Cpp_Statement_IterationStatement : public Cpp_Statement
{
public:
    Cpp_IterationStatement *iterationStatement;

    Cpp_Statement_IterationStatement ()
        : Cpp_Statement (Cpp_Statement::_IterationStatement)
          , iterationStatement (NULL)
    {
    }
};

class Cpp_Statement_JumpStatement : public Cpp_Statement
{
public:
    Cpp_JumpStatement *jumpStatement;

    Cpp_Statement_JumpStatement ()
        : Cpp_Statement (Cpp_Statement::_JumpStatement)
          , jumpStatement (NULL)
    {
    }
};

class Cpp_Statement_TryBlock : public Cpp_Statement
{
public:
    Cpp_TryBlock *tryBlock;

    Cpp_Statement_TryBlock ()
        : Cpp_Statement (Cpp_Statement::_TryBlock)
          , tryBlock (NULL)
    {
    }
};

void dump_cpp_Statement (Cpp_Statement const *, MyCpp::Size nest_level = 0);

bool cpp_LabeledStatement_accept_func (
        Cpp_LabeledStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_begin_statement (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_LabeledStatement : public CppElement
{
public:
    enum Type {
        _Label,
        _Case,
        _Default
    };

    const Type labeled_statement_type;

    Cpp_LabeledStatement (Type type)
        : CppElement (CppElement::_LabeledStatement),
          labeled_statement_type (type)
    {
    }
};

bool cpp_LabeledStatement_accept_func (
        Cpp_LabeledStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_begin_statement (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_LabeledStatement_Label : public Cpp_LabeledStatement
{
public:
    Cpp_Identifier *identifier;
    Cpp_Statement *statement;

    Cpp_LabeledStatement_Label ()
        : Cpp_LabeledStatement (Cpp_LabeledStatement::_Label)
          , identifier (NULL)
          , statement (NULL)
    {
    }
};

class Cpp_LabeledStatement_Case : public Cpp_LabeledStatement
{
public:
    Cpp_ConstantExpression *constantExpression;
    Cpp_Statement *statement;

    Cpp_LabeledStatement_Case ()
        : Cpp_LabeledStatement (Cpp_LabeledStatement::_Case)
          , constantExpression (NULL)
          , statement (NULL)
    {
    }
};

class Cpp_LabeledStatement_Default : public Cpp_LabeledStatement
{
public:
    Cpp_Statement *statement;

    Cpp_LabeledStatement_Default ()
        : Cpp_LabeledStatement (Cpp_LabeledStatement::_Default)
          , statement (NULL)
    {
    }
};

void dump_cpp_LabeledStatement (Cpp_LabeledStatement const *, MyCpp::Size nest_level = 0);

class Cpp_ExpressionStatement : public CppElement
{
public:
    Cpp_Expression *expression;

    Cpp_ExpressionStatement ()
        : CppElement (CppElement::_ExpressionStatement)
          , expression (NULL)
    {
    }
};

void dump_cpp_ExpressionStatement (Cpp_ExpressionStatement const *, MyCpp::Size nest_level = 0);

bool cpp_begin_function_definition (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_begin_temporal_namespace (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_compound_statement (
        Cpp_CompoundStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_CompoundStatement : public CppElement
{
public:
    MyCpp::List<Cpp_Statement*> statements;

    Cpp_CompoundStatement ()
        : CppElement (CppElement::_CompoundStatement)
    {
    }
};

void dump_cpp_CompoundStatement (Cpp_CompoundStatement const *, MyCpp::Size nest_level = 0);

bool cpp_begin_condition (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_selection_statement (
        Cpp_SelectionStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_SelectionStatement : public CppElement
{
public:
    enum Type {
        _IfElse,
        _If,
        _Switch
    };

    const Type selection_statement_type;

    Cpp_SelectionStatement (Type type)
        : CppElement (CppElement::_SelectionStatement),
          selection_statement_type (type)
    {
    }
};

bool cpp_begin_condition (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_selection_statement (
        Cpp_SelectionStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_SelectionStatement_IfElse : public Cpp_SelectionStatement
{
public:
    Cpp_Condition *condition;
    Cpp_Statement *statement;
    Cpp_Statement *elseStatement;

    Cpp_SelectionStatement_IfElse ()
        : Cpp_SelectionStatement (Cpp_SelectionStatement::_IfElse)
          , condition (NULL)
          , statement (NULL)
          , elseStatement (NULL)
    {
    }
};

class Cpp_SelectionStatement_If : public Cpp_SelectionStatement
{
public:
    Cpp_Condition *condition;
    Cpp_Statement *statement;

    Cpp_SelectionStatement_If ()
        : Cpp_SelectionStatement (Cpp_SelectionStatement::_If)
          , condition (NULL)
          , statement (NULL)
    {
    }
};

class Cpp_SelectionStatement_Switch : public Cpp_SelectionStatement
{
public:
    Cpp_Condition *condition;
    Cpp_Statement *statement;

    Cpp_SelectionStatement_Switch ()
        : Cpp_SelectionStatement (Cpp_SelectionStatement::_Switch)
          , condition (NULL)
          , statement (NULL)
    {
    }
};

void dump_cpp_SelectionStatement (Cpp_SelectionStatement const *, MyCpp::Size nest_level = 0);

bool cpp_accept_condition (
        Cpp_Condition *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_Condition : public CppElement
{
public:
    enum Type {
        _Expression,
        _Declarator
    };

    const Type condition_type;

    Cpp_Condition (Type type)
        : CppElement (CppElement::_Condition),
          condition_type (type)
    {
    }
};

bool cpp_accept_condition (
        Cpp_Condition *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_Condition_Expression : public Cpp_Condition
{
public:
    Cpp_Expression *expression;

    Cpp_Condition_Expression ()
        : Cpp_Condition (Cpp_Condition::_Expression)
          , expression (NULL)
    {
    }
};

bool cpp_begin_dummy_constructor_ambiguity (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_Condition_Declarator : public Cpp_Condition
{
public:
    Cpp_TypeSpecifierSeq *typeSpecifierSeq;
    Cpp_Declarator *declarator;
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_Condition_Declarator ()
        : Cpp_Condition (Cpp_Condition::_Declarator)
          , typeSpecifierSeq (NULL)
          , declarator (NULL)
          , assignmentExpression (NULL)
    {
    }
};

void dump_cpp_Condition (Cpp_Condition const *, MyCpp::Size nest_level = 0);

bool cpp_accept_iteration_statement (
        Cpp_IterationStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_IterationStatement : public CppElement
{
public:
    enum Type {
        _While,
        _DoWhile,
        _For
    };

    const Type iteration_statement_type;

    Cpp_IterationStatement (Type type)
        : CppElement (CppElement::_IterationStatement),
          iteration_statement_type (type)
    {
    }
};

bool cpp_accept_iteration_statement (
        Cpp_IterationStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_IterationStatement_While : public Cpp_IterationStatement
{
public:
    Cpp_Condition *condition;
    Cpp_Statement *statement;

    Cpp_IterationStatement_While ()
        : Cpp_IterationStatement (Cpp_IterationStatement::_While)
          , condition (NULL)
          , statement (NULL)
    {
    }
};

class Cpp_IterationStatement_DoWhile : public Cpp_IterationStatement
{
public:
    Cpp_Statement *statement;
    Cpp_Expression *expression;

    Cpp_IterationStatement_DoWhile ()
        : Cpp_IterationStatement (Cpp_IterationStatement::_DoWhile)
          , statement (NULL)
          , expression (NULL)
    {
    }
};

bool cpp_begin_for_init_statement (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_IterationStatement_For : public Cpp_IterationStatement
{
public:
    Cpp_ForInitStatement *forInitStatement;
    Cpp_Condition *condition;
    Cpp_Expression *expression;
    Cpp_Statement *statement;

    Cpp_IterationStatement_For ()
        : Cpp_IterationStatement (Cpp_IterationStatement::_For)
          , forInitStatement (NULL)
          , condition (NULL)
          , expression (NULL)
          , statement (NULL)
    {
    }
};

void dump_cpp_IterationStatement (Cpp_IterationStatement const *, MyCpp::Size nest_level = 0);

bool cpp_accept_for_init_statement (
        Cpp_ForInitStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ForInitStatement : public CppElement
{
public:
    enum Type {
        _Declaration,
        _Expression
    };

    const Type for_init_statement_type;

    Cpp_ForInitStatement (Type type)
        : CppElement (CppElement::_ForInitStatement),
          for_init_statement_type (type)
    {
    }
};

bool cpp_accept_for_init_statement (
        Cpp_ForInitStatement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ForInitStatement_Declaration : public Cpp_ForInitStatement
{
public:
    Cpp_SimpleDeclaration *simpleDeclaration;

    Cpp_ForInitStatement_Declaration ()
        : Cpp_ForInitStatement (Cpp_ForInitStatement::_Declaration)
          , simpleDeclaration (NULL)
    {
    }
};

class Cpp_ForInitStatement_Expression : public Cpp_ForInitStatement
{
public:
    Cpp_ExpressionStatement *expressionStatement;

    Cpp_ForInitStatement_Expression ()
        : Cpp_ForInitStatement (Cpp_ForInitStatement::_Expression)
          , expressionStatement (NULL)
    {
    }
};

void dump_cpp_ForInitStatement (Cpp_ForInitStatement const *, MyCpp::Size nest_level = 0);

class Cpp_JumpStatement : public CppElement
{
public:
    enum Type {
        _Break,
        _Continue,
        _Return,
        _Goto
    };

    const Type jump_statement_type;

    Cpp_JumpStatement (Type type)
        : CppElement (CppElement::_JumpStatement),
          jump_statement_type (type)
    {
    }
};

class Cpp_JumpStatement_Break : public Cpp_JumpStatement
{
public:

    Cpp_JumpStatement_Break ()
        : Cpp_JumpStatement (Cpp_JumpStatement::_Break)
    {
    }
};

class Cpp_JumpStatement_Continue : public Cpp_JumpStatement
{
public:

    Cpp_JumpStatement_Continue ()
        : Cpp_JumpStatement (Cpp_JumpStatement::_Continue)
    {
    }
};

class Cpp_JumpStatement_Return : public Cpp_JumpStatement
{
public:
    Cpp_Expression *expression;

    Cpp_JumpStatement_Return ()
        : Cpp_JumpStatement (Cpp_JumpStatement::_Return)
          , expression (NULL)
    {
    }
};

class Cpp_JumpStatement_Goto : public Cpp_JumpStatement
{
public:
    Cpp_Identifier *identifier;

    Cpp_JumpStatement_Goto ()
        : Cpp_JumpStatement (Cpp_JumpStatement::_Goto)
          , identifier (NULL)
    {
    }
};

void dump_cpp_JumpStatement (Cpp_JumpStatement const *, MyCpp::Size nest_level = 0);

class Cpp_DeclarationStatement : public CppElement
{
public:
    Cpp_BlockDeclaration *blockDeclaration;

    Cpp_DeclarationStatement ()
        : CppElement (CppElement::_DeclarationStatement)
          , blockDeclaration (NULL)
    {
    }
};

void dump_cpp_DeclarationStatement (Cpp_DeclarationStatement const *, MyCpp::Size nest_level = 0);

class Cpp_DeclarationSeq : public CppElement
{
public:
    enum Type {
        _DeclarationSeq,
        _Declaration
    };

    const Type declaration_seq_type;

    Cpp_DeclarationSeq (Type type)
        : CppElement (CppElement::_DeclarationSeq),
          declaration_seq_type (type)
    {
    }
};

class Cpp_DeclarationSeq_DeclarationSeq : public Cpp_DeclarationSeq
{
public:
    Cpp_DeclarationSeq *declarationSeq;
    Cpp_Declaration *declaration;

    Cpp_DeclarationSeq_DeclarationSeq ()
        : Cpp_DeclarationSeq (Cpp_DeclarationSeq::_DeclarationSeq)
          , declarationSeq (NULL)
          , declaration (NULL)
    {
    }
};

class Cpp_DeclarationSeq_Declaration : public Cpp_DeclarationSeq
{
public:
    Cpp_Declaration *declaration;

    Cpp_DeclarationSeq_Declaration ()
        : Cpp_DeclarationSeq (Cpp_DeclarationSeq::_Declaration)
          , declaration (NULL)
    {
    }
};

void dump_cpp_DeclarationSeq (Cpp_DeclarationSeq const *, MyCpp::Size nest_level = 0);

class Cpp_Declaration : public CppElement
{
public:
    enum Type {
        _BlockDeclaration,
        _FunctionDefinition,
        _TemplateDeclaration,
        _ExplicitInstantiation,
        _ExplicitSpecialization,
        _LinkageSpecification,
        _NamespaceDefinition
    };

    const Type declaration_type;

    Cpp_Declaration (Type type)
        : CppElement (CppElement::_Declaration),
          declaration_type (type)
    {
    }
};

class Cpp_Declaration_BlockDeclaration : public Cpp_Declaration
{
public:
    Cpp_BlockDeclaration *blockDeclaration;

    Cpp_Declaration_BlockDeclaration ()
        : Cpp_Declaration (Cpp_Declaration::_BlockDeclaration)
          , blockDeclaration (NULL)
    {
    }
};

class Cpp_Declaration_FunctionDefinition : public Cpp_Declaration
{
public:
    Cpp_FunctionDefinition *functionDefinition;

    Cpp_Declaration_FunctionDefinition ()
        : Cpp_Declaration (Cpp_Declaration::_FunctionDefinition)
          , functionDefinition (NULL)
    {
    }
};

class Cpp_Declaration_TemplateDeclaration : public Cpp_Declaration
{
public:
    Cpp_TemplateDeclaration *templateDeclaration;

    Cpp_Declaration_TemplateDeclaration ()
        : Cpp_Declaration (Cpp_Declaration::_TemplateDeclaration)
          , templateDeclaration (NULL)
    {
    }
};

class Cpp_Declaration_ExplicitInstantiation : public Cpp_Declaration
{
public:
    Cpp_ExplicitInstantiation *explicitInstantiation;

    Cpp_Declaration_ExplicitInstantiation ()
        : Cpp_Declaration (Cpp_Declaration::_ExplicitInstantiation)
          , explicitInstantiation (NULL)
    {
    }
};

class Cpp_Declaration_ExplicitSpecialization : public Cpp_Declaration
{
public:
    Cpp_ExplicitSpecialization *explicitSpecialization;

    Cpp_Declaration_ExplicitSpecialization ()
        : Cpp_Declaration (Cpp_Declaration::_ExplicitSpecialization)
          , explicitSpecialization (NULL)
    {
    }
};

class Cpp_Declaration_LinkageSpecification : public Cpp_Declaration
{
public:
    Cpp_LinkageSpecification *linkageSpecification;

    Cpp_Declaration_LinkageSpecification ()
        : Cpp_Declaration (Cpp_Declaration::_LinkageSpecification)
          , linkageSpecification (NULL)
    {
    }
};

class Cpp_Declaration_NamespaceDefinition : public Cpp_Declaration
{
public:
    Cpp_NamespaceDefinition *namespaceDefinition;

    Cpp_Declaration_NamespaceDefinition ()
        : Cpp_Declaration (Cpp_Declaration::_NamespaceDefinition)
          , namespaceDefinition (NULL)
    {
    }
};

void dump_cpp_Declaration (Cpp_Declaration const *, MyCpp::Size nest_level = 0);

class Cpp_BlockDeclaration : public CppElement
{
public:
    enum Type {
        _SimpleDeclaration,
        _AsmDefinition,
        _NamespaceAliasDefinition,
        _UsingDeclaration,
        _UsingDirective
    };

    const Type block_declaration_type;

    Cpp_BlockDeclaration (Type type)
        : CppElement (CppElement::_BlockDeclaration),
          block_declaration_type (type)
    {
    }
};

class Cpp_BlockDeclaration_SimpleDeclaration : public Cpp_BlockDeclaration
{
public:
    Cpp_SimpleDeclaration *simpleDeclaration;

    Cpp_BlockDeclaration_SimpleDeclaration ()
        : Cpp_BlockDeclaration (Cpp_BlockDeclaration::_SimpleDeclaration)
          , simpleDeclaration (NULL)
    {
    }
};

class Cpp_BlockDeclaration_AsmDefinition : public Cpp_BlockDeclaration
{
public:
    Cpp_AsmDefinition *asmDefinition;

    Cpp_BlockDeclaration_AsmDefinition ()
        : Cpp_BlockDeclaration (Cpp_BlockDeclaration::_AsmDefinition)
          , asmDefinition (NULL)
    {
    }
};

class Cpp_BlockDeclaration_NamespaceAliasDefinition : public Cpp_BlockDeclaration
{
public:
    Cpp_NamespaceAliasDefinition *namespaceAliasDefinition;

    Cpp_BlockDeclaration_NamespaceAliasDefinition ()
        : Cpp_BlockDeclaration (Cpp_BlockDeclaration::_NamespaceAliasDefinition)
          , namespaceAliasDefinition (NULL)
    {
    }
};

class Cpp_BlockDeclaration_UsingDeclaration : public Cpp_BlockDeclaration
{
public:
    Cpp_UsingDeclaration *usingDeclaration;

    Cpp_BlockDeclaration_UsingDeclaration ()
        : Cpp_BlockDeclaration (Cpp_BlockDeclaration::_UsingDeclaration)
          , usingDeclaration (NULL)
    {
    }
};

class Cpp_BlockDeclaration_UsingDirective : public Cpp_BlockDeclaration
{
public:
    Cpp_UsingDirective *usingDirective;

    Cpp_BlockDeclaration_UsingDirective ()
        : Cpp_BlockDeclaration (Cpp_BlockDeclaration::_UsingDirective)
          , usingDirective (NULL)
    {
    }
};

void dump_cpp_BlockDeclaration (Cpp_BlockDeclaration const *, MyCpp::Size nest_level = 0);

bool cpp_begin_constructor_ambiguity (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_SimpleDeclaration : public CppElement
{
public:
    Cpp_DeclSpecifierSeq *declSpecifierSeq;
    Cpp_InitDeclaratorList *initDeclaratorList;

    Cpp_SimpleDeclaration ()
        : CppElement (CppElement::_SimpleDeclaration)
          , declSpecifierSeq (NULL)
          , initDeclaratorList (NULL)
    {
    }
};

void dump_cpp_SimpleDeclaration (Cpp_SimpleDeclaration const *, MyCpp::Size nest_level = 0);

bool cpp_accept_decl_specifier__storage_class_specifier (
        Cpp_DeclSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_DeclSpecifier : public CppElement
{
public:
    enum Type {
        _StorageClassSpecifier,
        _TypeSpecifier,
        _FunctionSpecifier,
        _Friend,
        _Typedef
    };

    const Type decl_specifier_type;

    Cpp_DeclSpecifier (Type type)
        : CppElement (CppElement::_DeclSpecifier),
          decl_specifier_type (type)
    {
    }
};

bool cpp_accept_decl_specifier__storage_class_specifier (
        Cpp_DeclSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_DeclSpecifier_StorageClassSpecifier : public Cpp_DeclSpecifier
{
public:
    Cpp_StorageClassSpecifier *storageClassSpecifier;

    Cpp_DeclSpecifier_StorageClassSpecifier ()
        : Cpp_DeclSpecifier (Cpp_DeclSpecifier::_StorageClassSpecifier)
          , storageClassSpecifier (NULL)
    {
    }
};

class Cpp_DeclSpecifier_TypeSpecifier : public Cpp_DeclSpecifier
{
public:
    Cpp_TypeSpecifier *typeSpecifier;

    Cpp_DeclSpecifier_TypeSpecifier ()
        : Cpp_DeclSpecifier (Cpp_DeclSpecifier::_TypeSpecifier)
          , typeSpecifier (NULL)
    {
    }
};

bool cpp_accept_decl_specifier__function_specifier (
        Cpp_DeclSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_DeclSpecifier_FunctionSpecifier : public Cpp_DeclSpecifier
{
public:
    Cpp_FunctionSpecifier *functionSpecifier;

    Cpp_DeclSpecifier_FunctionSpecifier ()
        : Cpp_DeclSpecifier (Cpp_DeclSpecifier::_FunctionSpecifier)
          , functionSpecifier (NULL)
    {
    }
};

bool cpp_accept_decl_specifier__friend (
        Cpp_DeclSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_DeclSpecifier_Friend : public Cpp_DeclSpecifier
{
public:

    Cpp_DeclSpecifier_Friend ()
        : Cpp_DeclSpecifier (Cpp_DeclSpecifier::_Friend)
    {
    }
};

bool cpp_accept_decl_specifier__typedef (
        Cpp_DeclSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_DeclSpecifier_Typedef : public Cpp_DeclSpecifier
{
public:

    Cpp_DeclSpecifier_Typedef ()
        : Cpp_DeclSpecifier (Cpp_DeclSpecifier::_Typedef)
    {
    }
};

void dump_cpp_DeclSpecifier (Cpp_DeclSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_DeclSpecifierSeq : public CppElement
{
public:
    Cpp_DeclSpecifier *declSpecifier;
    Cpp_DeclSpecifierSeq *declSpecifierSeq;

    Cpp_DeclSpecifierSeq ()
        : CppElement (CppElement::_DeclSpecifierSeq)
          , declSpecifier (NULL)
          , declSpecifierSeq (NULL)
    {
    }
};

void dump_cpp_DeclSpecifierSeq (Cpp_DeclSpecifierSeq const *, MyCpp::Size nest_level = 0);

class Cpp_StorageClassSpecifier : public CppElement
{
public:
    enum Type {
        _Auto,
        _Register,
        _Static,
        _Extern,
        _Mutable
    };

    const Type storage_class_specifier_type;

    Cpp_StorageClassSpecifier (Type type)
        : CppElement (CppElement::_StorageClassSpecifier),
          storage_class_specifier_type (type)
    {
    }
};

class Cpp_StorageClassSpecifier_Auto : public Cpp_StorageClassSpecifier
{
public:

    Cpp_StorageClassSpecifier_Auto ()
        : Cpp_StorageClassSpecifier (Cpp_StorageClassSpecifier::_Auto)
    {
    }
};

class Cpp_StorageClassSpecifier_Register : public Cpp_StorageClassSpecifier
{
public:

    Cpp_StorageClassSpecifier_Register ()
        : Cpp_StorageClassSpecifier (Cpp_StorageClassSpecifier::_Register)
    {
    }
};

class Cpp_StorageClassSpecifier_Static : public Cpp_StorageClassSpecifier
{
public:

    Cpp_StorageClassSpecifier_Static ()
        : Cpp_StorageClassSpecifier (Cpp_StorageClassSpecifier::_Static)
    {
    }
};

class Cpp_StorageClassSpecifier_Extern : public Cpp_StorageClassSpecifier
{
public:

    Cpp_StorageClassSpecifier_Extern ()
        : Cpp_StorageClassSpecifier (Cpp_StorageClassSpecifier::_Extern)
    {
    }
};

class Cpp_StorageClassSpecifier_Mutable : public Cpp_StorageClassSpecifier
{
public:

    Cpp_StorageClassSpecifier_Mutable ()
        : Cpp_StorageClassSpecifier (Cpp_StorageClassSpecifier::_Mutable)
    {
    }
};

void dump_cpp_StorageClassSpecifier (Cpp_StorageClassSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_FunctionSpecifier : public CppElement
{
public:
    enum Type {
        _Inline,
        _Virtual,
        _Explicit
    };

    const Type function_specifier_type;

    Cpp_FunctionSpecifier (Type type)
        : CppElement (CppElement::_FunctionSpecifier),
          function_specifier_type (type)
    {
    }
};

class Cpp_FunctionSpecifier_Inline : public Cpp_FunctionSpecifier
{
public:

    Cpp_FunctionSpecifier_Inline ()
        : Cpp_FunctionSpecifier (Cpp_FunctionSpecifier::_Inline)
    {
    }
};

class Cpp_FunctionSpecifier_Virtual : public Cpp_FunctionSpecifier
{
public:

    Cpp_FunctionSpecifier_Virtual ()
        : Cpp_FunctionSpecifier (Cpp_FunctionSpecifier::_Virtual)
    {
    }
};

class Cpp_FunctionSpecifier_Explicit : public Cpp_FunctionSpecifier
{
public:

    Cpp_FunctionSpecifier_Explicit ()
        : Cpp_FunctionSpecifier (Cpp_FunctionSpecifier::_Explicit)
    {
    }
};

void dump_cpp_FunctionSpecifier (Cpp_FunctionSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_TypedefName : public CppElement
{
public:
    Cpp_Identifier *identifier;

    Cpp_TypedefName ()
        : CppElement (CppElement::_TypedefName)
          , identifier (NULL)
    {
    }
};

void dump_cpp_TypedefName (Cpp_TypedefName const *, MyCpp::Size nest_level = 0);

class Cpp_TypeSpecifier : public CppElement
{
public:
    enum Type {
        _SimpleTypeSpecifier,
        _ClassSpecifier,
        _EnumSpecifier,
        _ElaboratedTypeSpecifier,
        _CvQualifier
    };

    const Type type_specifier_type;

    Cpp_TypeSpecifier (Type type)
        : CppElement (CppElement::_TypeSpecifier),
          type_specifier_type (type)
    {
    }
};

class Cpp_TypeSpecifier_SimpleTypeSpecifier : public Cpp_TypeSpecifier
{
public:
    Cpp_SimpleTypeSpecifier *simpleTypeSpecifier;

    Cpp_TypeSpecifier_SimpleTypeSpecifier ()
        : Cpp_TypeSpecifier (Cpp_TypeSpecifier::_SimpleTypeSpecifier)
          , simpleTypeSpecifier (NULL)
    {
    }
};

class Cpp_TypeSpecifier_ClassSpecifier : public Cpp_TypeSpecifier
{
public:
    Cpp_ClassSpecifier *classSpecifier;

    Cpp_TypeSpecifier_ClassSpecifier ()
        : Cpp_TypeSpecifier (Cpp_TypeSpecifier::_ClassSpecifier)
          , classSpecifier (NULL)
    {
    }
};

class Cpp_TypeSpecifier_EnumSpecifier : public Cpp_TypeSpecifier
{
public:
    Cpp_EnumSpecifier *enumSpecifier;

    Cpp_TypeSpecifier_EnumSpecifier ()
        : Cpp_TypeSpecifier (Cpp_TypeSpecifier::_EnumSpecifier)
          , enumSpecifier (NULL)
    {
    }
};

class Cpp_TypeSpecifier_ElaboratedTypeSpecifier : public Cpp_TypeSpecifier
{
public:
    Cpp_ElaboratedTypeSpecifier *elaboratedTypeSpecifier;

    Cpp_TypeSpecifier_ElaboratedTypeSpecifier ()
        : Cpp_TypeSpecifier (Cpp_TypeSpecifier::_ElaboratedTypeSpecifier)
          , elaboratedTypeSpecifier (NULL)
    {
    }
};

bool cpp_accept_type_specifier__cv_qualifier (
        Cpp_TypeSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TypeSpecifier_CvQualifier : public Cpp_TypeSpecifier
{
public:
    Cpp_CvQualifier *cvQualifier;

    Cpp_TypeSpecifier_CvQualifier ()
        : Cpp_TypeSpecifier (Cpp_TypeSpecifier::_CvQualifier)
          , cvQualifier (NULL)
    {
    }
};

void dump_cpp_TypeSpecifier (Cpp_TypeSpecifier const *, MyCpp::Size nest_level = 0);

bool cpp_accept_simple_type_specifier (
        Cpp_SimpleTypeSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_SimpleTypeSpecifier : public CppElement
{
public:
    enum Type {
        _Void,
        _Bool,
        _Int,
        _Char,
        _Unsigned,
        _Long,
        _Float,
        _Double,
        _Short,
        _WcharT,
        _Signed,
        _TypeName,
        _TemplateId
    };

    const Type simple_type_specifier_type;

    Cpp_SimpleTypeSpecifier (Type type)
        : CppElement (CppElement::_SimpleTypeSpecifier),
          simple_type_specifier_type (type)
    {
    }
};

bool cpp_accept_simple_type_specifier (
        Cpp_SimpleTypeSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_SimpleTypeSpecifier_Void : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Void ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Void)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Bool : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Bool ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Bool)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Int : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Int ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Int)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Char : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Char ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Char)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Unsigned : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Unsigned ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Unsigned)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Long : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Long ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Long)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Float : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Float ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Float)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Double : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Double ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Double)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Short : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Short ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Short)
    {
    }
};

class Cpp_SimpleTypeSpecifier_WcharT : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_WcharT ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_WcharT)
    {
    }
};

class Cpp_SimpleTypeSpecifier_Signed : public Cpp_SimpleTypeSpecifier
{
public:

    Cpp_SimpleTypeSpecifier_Signed ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_Signed)
    {
    }
};

class Cpp_SimpleTypeSpecifier_TypeName : public Cpp_SimpleTypeSpecifier
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TypeName *typeName;

    Cpp_SimpleTypeSpecifier_TypeName ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_TypeName)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , typeName (NULL)
    {
    }
};

class Cpp_SimpleTypeSpecifier_TemplateId : public Cpp_SimpleTypeSpecifier
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TemplateId *templateId;

    Cpp_SimpleTypeSpecifier_TemplateId ()
        : Cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier::_TemplateId)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , templateId (NULL)
    {
    }
};

void dump_cpp_SimpleTypeSpecifier (Cpp_SimpleTypeSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_TypeName : public CppElement
{
public:
    enum Type {
        _ClassName,
        _EnumName,
        _TypedefName
    };

    const Type type_name_type;

    Cpp_TypeName (Type type)
        : CppElement (CppElement::_TypeName),
          type_name_type (type)
    {
    }
};

class Cpp_TypeName_ClassName : public Cpp_TypeName
{
public:
    Cpp_ClassName *className;

    Cpp_TypeName_ClassName ()
        : Cpp_TypeName (Cpp_TypeName::_ClassName)
          , className (NULL)
    {
    }
};

class Cpp_TypeName_EnumName : public Cpp_TypeName
{
public:
    Cpp_EnumName *enumName;

    Cpp_TypeName_EnumName ()
        : Cpp_TypeName (Cpp_TypeName::_EnumName)
          , enumName (NULL)
    {
    }
};

class Cpp_TypeName_TypedefName : public Cpp_TypeName
{
public:
    Cpp_TypedefName *typedefName;

    Cpp_TypeName_TypedefName ()
        : Cpp_TypeName (Cpp_TypeName::_TypedefName)
          , typedefName (NULL)
    {
    }
};

void dump_cpp_TypeName (Cpp_TypeName const *, MyCpp::Size nest_level = 0);

bool cpp_accept_elaborated_type_specifier (
        Cpp_ElaboratedTypeSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ElaboratedTypeSpecifier : public CppElement
{
public:
    enum Type {
        _Class,
        _Enum,
        _Typename,
        _TypenameTemplate
    };

    const Type elaborated_type_specifier_type;

    Cpp_ElaboratedTypeSpecifier (Type type)
        : CppElement (CppElement::_ElaboratedTypeSpecifier),
          elaborated_type_specifier_type (type)
    {
    }
};

bool cpp_accept_elaborated_type_specifier (
        Cpp_ElaboratedTypeSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ElaboratedTypeSpecifier_Class : public Cpp_ElaboratedTypeSpecifier
{
public:
    Cpp_ClassKey *classKey;
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_Identifier *identifier;

    Cpp_ElaboratedTypeSpecifier_Class ()
        : Cpp_ElaboratedTypeSpecifier (Cpp_ElaboratedTypeSpecifier::_Class)
          , classKey (NULL)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , identifier (NULL)
    {
    }
};

class Cpp_ElaboratedTypeSpecifier_Enum : public Cpp_ElaboratedTypeSpecifier
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_Identifier *identifier;

    Cpp_ElaboratedTypeSpecifier_Enum ()
        : Cpp_ElaboratedTypeSpecifier (Cpp_ElaboratedTypeSpecifier::_Enum)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , identifier (NULL)
    {
    }
};

class Cpp_ElaboratedTypeSpecifier_Typename : public Cpp_ElaboratedTypeSpecifier
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_Identifier *identifier;

    Cpp_ElaboratedTypeSpecifier_Typename ()
        : Cpp_ElaboratedTypeSpecifier (Cpp_ElaboratedTypeSpecifier::_Typename)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , identifier (NULL)
    {
    }
};

class Cpp_ElaboratedTypeSpecifier_TypenameTemplate : public Cpp_ElaboratedTypeSpecifier
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TemplateId *templateId;

    Cpp_ElaboratedTypeSpecifier_TypenameTemplate ()
        : Cpp_ElaboratedTypeSpecifier (Cpp_ElaboratedTypeSpecifier::_TypenameTemplate)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , templateId (NULL)
    {
    }
};

void dump_cpp_ElaboratedTypeSpecifier (Cpp_ElaboratedTypeSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_EnumName : public CppElement
{
public:
    Cpp_Identifier *identifier;

    Cpp_EnumName ()
        : CppElement (CppElement::_EnumName)
          , identifier (NULL)
    {
    }
};

void dump_cpp_EnumName (Cpp_EnumName const *, MyCpp::Size nest_level = 0);

bool cpp_accept_enum_specifier (
        Cpp_EnumSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_EnumSpecifier : public CppElement
{
public:
    Cpp_Identifier *identifier;
    Cpp_EnumeratorList *enumeratorList;

    Cpp_EnumSpecifier ()
        : CppElement (CppElement::_EnumSpecifier)
          , identifier (NULL)
          , enumeratorList (NULL)
    {
    }
};

void dump_cpp_EnumSpecifier (Cpp_EnumSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_EnumeratorList : public CppElement
{
public:
    enum Type {
        _EnumeratorList,
        _EnumeratorDefinition
    };

    const Type enumerator_list_type;

    Cpp_EnumeratorList (Type type)
        : CppElement (CppElement::_EnumeratorList),
          enumerator_list_type (type)
    {
    }
};

class Cpp_EnumeratorList_EnumeratorList : public Cpp_EnumeratorList
{
public:
    Cpp_EnumeratorDefinition *enumeratorDefinition;
    Cpp_EnumeratorList *enumeratorList;

    Cpp_EnumeratorList_EnumeratorList ()
        : Cpp_EnumeratorList (Cpp_EnumeratorList::_EnumeratorList)
          , enumeratorDefinition (NULL)
          , enumeratorList (NULL)
    {
    }
};

class Cpp_EnumeratorList_EnumeratorDefinition : public Cpp_EnumeratorList
{
public:
    Cpp_EnumeratorDefinition *enumeratorDefinition;

    Cpp_EnumeratorList_EnumeratorDefinition ()
        : Cpp_EnumeratorList (Cpp_EnumeratorList::_EnumeratorDefinition)
          , enumeratorDefinition (NULL)
    {
    }
};

void dump_cpp_EnumeratorList (Cpp_EnumeratorList const *, MyCpp::Size nest_level = 0);

class Cpp_EnumeratorDefinition : public CppElement
{
public:
    enum Type {
        _Initializer,
        _Enumerator
    };

    const Type enumerator_definition_type;

    Cpp_EnumeratorDefinition (Type type)
        : CppElement (CppElement::_EnumeratorDefinition),
          enumerator_definition_type (type)
    {
    }
};

class Cpp_EnumeratorDefinition_Initializer : public Cpp_EnumeratorDefinition
{
public:
    Cpp_Enumerator *enumerator;
    Cpp_ConstantExpression *constantExpression;

    Cpp_EnumeratorDefinition_Initializer ()
        : Cpp_EnumeratorDefinition (Cpp_EnumeratorDefinition::_Initializer)
          , enumerator (NULL)
          , constantExpression (NULL)
    {
    }
};

class Cpp_EnumeratorDefinition_Enumerator : public Cpp_EnumeratorDefinition
{
public:
    Cpp_Enumerator *enumerator;

    Cpp_EnumeratorDefinition_Enumerator ()
        : Cpp_EnumeratorDefinition (Cpp_EnumeratorDefinition::_Enumerator)
          , enumerator (NULL)
    {
    }
};

void dump_cpp_EnumeratorDefinition (Cpp_EnumeratorDefinition const *, MyCpp::Size nest_level = 0);

class Cpp_Enumerator : public CppElement
{
public:
    Cpp_Identifier *identifier;

    Cpp_Enumerator ()
        : CppElement (CppElement::_Enumerator)
          , identifier (NULL)
    {
    }
};

void dump_cpp_Enumerator (Cpp_Enumerator const *, MyCpp::Size nest_level = 0);

class Cpp_NamespaceName : public CppElement
{
public:
    Cpp_Identifier *identifier;

    Cpp_NamespaceName ()
        : CppElement (CppElement::_NamespaceName)
          , identifier (NULL)
    {
    }
};

void dump_cpp_NamespaceName (Cpp_NamespaceName const *, MyCpp::Size nest_level = 0);

class Cpp_NamespaceDefinition : public CppElement
{
public:
    enum Type {
        _NamedNamespaceDefinition,
        _UnnamedNamespaceDefinition
    };

    const Type namespace_definition_type;

    Cpp_NamespaceDefinition (Type type)
        : CppElement (CppElement::_NamespaceDefinition),
          namespace_definition_type (type)
    {
    }
};

class Cpp_NamespaceDefinition_NamedNamespaceDefinition : public Cpp_NamespaceDefinition
{
public:
    Cpp_NamedNamespaceDefinition *namedNamespaceDefinition;

    Cpp_NamespaceDefinition_NamedNamespaceDefinition ()
        : Cpp_NamespaceDefinition (Cpp_NamespaceDefinition::_NamedNamespaceDefinition)
          , namedNamespaceDefinition (NULL)
    {
    }
};

class Cpp_NamespaceDefinition_UnnamedNamespaceDefinition : public Cpp_NamespaceDefinition
{
public:
    Cpp_UnnamedNamespaceDefinition *unnamedNamespaceDefinition;

    Cpp_NamespaceDefinition_UnnamedNamespaceDefinition ()
        : Cpp_NamespaceDefinition (Cpp_NamespaceDefinition::_UnnamedNamespaceDefinition)
          , unnamedNamespaceDefinition (NULL)
    {
    }
};

void dump_cpp_NamespaceDefinition (Cpp_NamespaceDefinition const *, MyCpp::Size nest_level = 0);

bool cpp_NamedNamespaceDefinition_Identifier_accept_func (
        Cpp_NamedNamespaceDefinition *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_NamedNamespaceDefinition : public CppElement
{
public:
    Cpp_Identifier *identifier;
    Cpp_NamespaceBody *namespaceBody;

    Cpp_NamedNamespaceDefinition ()
        : CppElement (CppElement::_NamedNamespaceDefinition)
          , identifier (NULL)
          , namespaceBody (NULL)
    {
    }
};

void dump_cpp_NamedNamespaceDefinition (Cpp_NamedNamespaceDefinition const *, MyCpp::Size nest_level = 0);

class Cpp_UnnamedNamespaceDefinition : public CppElement
{
public:
    Cpp_NamespaceBody *namespaceBody;

    Cpp_UnnamedNamespaceDefinition ()
        : CppElement (CppElement::_UnnamedNamespaceDefinition)
          , namespaceBody (NULL)
    {
    }
};

void dump_cpp_UnnamedNamespaceDefinition (Cpp_UnnamedNamespaceDefinition const *, MyCpp::Size nest_level = 0);

class Cpp_NamespaceBody : public CppElement
{
public:
    Cpp_DeclarationSeq *declarationSeq;

    Cpp_NamespaceBody ()
        : CppElement (CppElement::_NamespaceBody)
          , declarationSeq (NULL)
    {
    }
};

void dump_cpp_NamespaceBody (Cpp_NamespaceBody const *, MyCpp::Size nest_level = 0);

class Cpp_NamespaceAliasDefinition : public CppElement
{
public:
    Cpp_Identifier *identifier;
    Cpp_QualifiedNamespaceSpecifier *qualifiedNamespaceSpecifier;

    Cpp_NamespaceAliasDefinition ()
        : CppElement (CppElement::_NamespaceAliasDefinition)
          , identifier (NULL)
          , qualifiedNamespaceSpecifier (NULL)
    {
    }
};

void dump_cpp_NamespaceAliasDefinition (Cpp_NamespaceAliasDefinition const *, MyCpp::Size nest_level = 0);

class Cpp_QualifiedNamespaceSpecifier : public CppElement
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_NamespaceName *namespaceName;

    Cpp_QualifiedNamespaceSpecifier ()
        : CppElement (CppElement::_QualifiedNamespaceSpecifier)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , namespaceName (NULL)
    {
    }
};

void dump_cpp_QualifiedNamespaceSpecifier (Cpp_QualifiedNamespaceSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_UsingDeclaration : public CppElement
{
public:
    enum Type {
        _NestedNameSpecifier,
        _Using
    };

    const Type using_declaration_type;

    Cpp_UsingDeclaration (Type type)
        : CppElement (CppElement::_UsingDeclaration),
          using_declaration_type (type)
    {
    }
};

class Cpp_UsingDeclaration_NestedNameSpecifier : public Cpp_UsingDeclaration
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_UnqualifiedId *unqualifiedId;

    Cpp_UsingDeclaration_NestedNameSpecifier ()
        : Cpp_UsingDeclaration (Cpp_UsingDeclaration::_NestedNameSpecifier)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , unqualifiedId (NULL)
    {
    }
};

class Cpp_UsingDeclaration_Using : public Cpp_UsingDeclaration
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_UnqualifiedId *unqualifiedId;

    Cpp_UsingDeclaration_Using ()
        : Cpp_UsingDeclaration (Cpp_UsingDeclaration::_Using)
          , scruffy_GlobalScope (NULL)
          , unqualifiedId (NULL)
    {
    }
};

void dump_cpp_UsingDeclaration (Cpp_UsingDeclaration const *, MyCpp::Size nest_level = 0);

class Cpp_UsingDirective : public CppElement
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_NamespaceName *namespaceName;

    Cpp_UsingDirective ()
        : CppElement (CppElement::_UsingDirective)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , namespaceName (NULL)
    {
    }
};

void dump_cpp_UsingDirective (Cpp_UsingDirective const *, MyCpp::Size nest_level = 0);

class Cpp_AsmDefinition : public CppElement
{
public:
    Cpp_StringLiteral *stringLiteral;

    Cpp_AsmDefinition ()
        : CppElement (CppElement::_AsmDefinition)
          , stringLiteral (NULL)
    {
    }
};

void dump_cpp_AsmDefinition (Cpp_AsmDefinition const *, MyCpp::Size nest_level = 0);

class Cpp_LinkageSpecification : public CppElement
{
public:
    enum Type {
        _DeclarationSeq,
        _Declaration
    };

    const Type linkage_specification_type;

    Cpp_LinkageSpecification (Type type)
        : CppElement (CppElement::_LinkageSpecification),
          linkage_specification_type (type)
    {
    }
};

class Cpp_LinkageSpecification_DeclarationSeq : public Cpp_LinkageSpecification
{
public:
    Cpp_StringLiteral *stringLiteral;
    Cpp_DeclarationSeq *declarationSeq;

    Cpp_LinkageSpecification_DeclarationSeq ()
        : Cpp_LinkageSpecification (Cpp_LinkageSpecification::_DeclarationSeq)
          , stringLiteral (NULL)
          , declarationSeq (NULL)
    {
    }
};

class Cpp_LinkageSpecification_Declaration : public Cpp_LinkageSpecification
{
public:
    Cpp_StringLiteral *stringLiteral;
    Cpp_Declaration *declaration;

    Cpp_LinkageSpecification_Declaration ()
        : Cpp_LinkageSpecification (Cpp_LinkageSpecification::_Declaration)
          , stringLiteral (NULL)
          , declaration (NULL)
    {
    }
};

void dump_cpp_LinkageSpecification (Cpp_LinkageSpecification const *, MyCpp::Size nest_level = 0);

bool cpp_reset_declarator (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_InitDeclaratorList : public CppElement
{
public:
    enum Type {
        _InitDeclaratorList,
        _InitDeclarator
    };

    const Type init_declarator_list_type;

    Cpp_InitDeclaratorList (Type type)
        : CppElement (CppElement::_InitDeclaratorList),
          init_declarator_list_type (type)
    {
    }
};

bool cpp_reset_declarator (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_InitDeclaratorList_InitDeclaratorList : public Cpp_InitDeclaratorList
{
public:
    Cpp_InitDeclarator *initDeclarator;
    Cpp_InitDeclaratorList *initDeclaratorList;

    Cpp_InitDeclaratorList_InitDeclaratorList ()
        : Cpp_InitDeclaratorList (Cpp_InitDeclaratorList::_InitDeclaratorList)
          , initDeclarator (NULL)
          , initDeclaratorList (NULL)
    {
    }
};

class Cpp_InitDeclaratorList_InitDeclarator : public Cpp_InitDeclaratorList
{
public:
    Cpp_InitDeclarator *initDeclarator;

    Cpp_InitDeclaratorList_InitDeclarator ()
        : Cpp_InitDeclaratorList (Cpp_InitDeclaratorList::_InitDeclarator)
          , initDeclarator (NULL)
    {
    }
};

void dump_cpp_InitDeclaratorList (Cpp_InitDeclaratorList const *, MyCpp::Size nest_level = 0);

bool cpp_begin_initializer (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_init_declarator_initializer (
        Cpp_InitDeclarator *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_InitDeclarator : public CppElement
{
public:
    Cpp_Declarator *declarator;
    Cpp_Initializer *initializer;

    Cpp_InitDeclarator ()
        : CppElement (CppElement::_InitDeclarator)
          , declarator (NULL)
          , initializer (NULL)
    {
    }
};

void dump_cpp_InitDeclarator (Cpp_InitDeclarator const *, MyCpp::Size nest_level = 0);

class Cpp_Declarator : public CppElement
{
public:
    enum Type {
        _PtrOperator,
        _DirectDeclarator
    };

    const Type declarator_type;

    Cpp_Declarator (Type type)
        : CppElement (CppElement::_Declarator),
          declarator_type (type)
    {
    }
};

class Cpp_Declarator_PtrOperator : public Cpp_Declarator
{
public:
    Cpp_PtrOperator *ptrOperator;
    Cpp_Declarator *declarator;

    Cpp_Declarator_PtrOperator ()
        : Cpp_Declarator (Cpp_Declarator::_PtrOperator)
          , ptrOperator (NULL)
          , declarator (NULL)
    {
    }
};

class Cpp_Declarator_DirectDeclarator : public Cpp_Declarator
{
public:
    Cpp_DirectDeclarator *directDeclarator;

    Cpp_Declarator_DirectDeclarator ()
        : Cpp_Declarator (Cpp_Declarator::_DirectDeclarator)
          , directDeclarator (NULL)
    {
    }
};

void dump_cpp_Declarator (Cpp_Declarator const *, MyCpp::Size nest_level = 0);

class Cpp_DirectDeclarator : public CppElement
{
public:
    enum Type {
        _Identifier,
        _Function,
        _Array,
        _Declarator
    };

    const Type direct_declarator_type;

    Cpp_DirectDeclarator (Type type)
        : CppElement (CppElement::_DirectDeclarator),
          direct_declarator_type (type)
    {
    }
};

class Cpp_DirectDeclarator_Identifier : public Cpp_DirectDeclarator
{
public:
    Cpp_DeclaratorId *declaratorId;

    Cpp_DirectDeclarator_Identifier ()
        : Cpp_DirectDeclarator (Cpp_DirectDeclarator::_Identifier)
          , declaratorId (NULL)
    {
    }
};

bool cpp_begin_function_parameters (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_function_declarator (
        Cpp_DirectDeclarator *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_DirectDeclarator_Function : public Cpp_DirectDeclarator
{
public:
    Cpp_DirectDeclarator *directDeclarator;
    Cpp_ParameterDeclarationClause *parameterDeclarationClause;
    Cpp_CvQualifierSeq *cvQualifierSeq;
    Cpp_ExceptionSpecification *exceptionSpecification;

    Cpp_DirectDeclarator_Function ()
        : Cpp_DirectDeclarator (Cpp_DirectDeclarator::_Function)
          , directDeclarator (NULL)
          , parameterDeclarationClause (NULL)
          , cvQualifierSeq (NULL)
          , exceptionSpecification (NULL)
    {
    }
};

class Cpp_DirectDeclarator_Array : public Cpp_DirectDeclarator
{
public:
    Cpp_DirectDeclarator *directDeclarator;
    Cpp_ConstantExpression *constantExpression;

    Cpp_DirectDeclarator_Array ()
        : Cpp_DirectDeclarator (Cpp_DirectDeclarator::_Array)
          , directDeclarator (NULL)
          , constantExpression (NULL)
    {
    }
};

class Cpp_DirectDeclarator_Declarator : public Cpp_DirectDeclarator
{
public:
    Cpp_Declarator *declarator;

    Cpp_DirectDeclarator_Declarator ()
        : Cpp_DirectDeclarator (Cpp_DirectDeclarator::_Declarator)
          , declarator (NULL)
    {
    }
};

void dump_cpp_DirectDeclarator (Cpp_DirectDeclarator const *, MyCpp::Size nest_level = 0);

class Cpp_PtrOperator : public CppElement
{
public:
    enum Type {
        _Pointer,
        _Reference,
        _PointerToMember
    };

    const Type ptr_operator_type;

    Cpp_PtrOperator (Type type)
        : CppElement (CppElement::_PtrOperator),
          ptr_operator_type (type)
    {
    }
};

class Cpp_PtrOperator_Pointer : public Cpp_PtrOperator
{
public:
    Cpp_CvQualifierSeq *cvQualifierSeq;

    Cpp_PtrOperator_Pointer ()
        : Cpp_PtrOperator (Cpp_PtrOperator::_Pointer)
          , cvQualifierSeq (NULL)
    {
    }
};

class Cpp_PtrOperator_Reference : public Cpp_PtrOperator
{
public:

    Cpp_PtrOperator_Reference ()
        : Cpp_PtrOperator (Cpp_PtrOperator::_Reference)
    {
    }
};

class Cpp_PtrOperator_PointerToMember : public Cpp_PtrOperator
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_CvQualifierSeq *cvQualifierSeq;

    Cpp_PtrOperator_PointerToMember ()
        : Cpp_PtrOperator (Cpp_PtrOperator::_PointerToMember)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , cvQualifierSeq (NULL)
    {
    }
};

void dump_cpp_PtrOperator (Cpp_PtrOperator const *, MyCpp::Size nest_level = 0);

class Cpp_CvQualifierSeq : public CppElement
{
public:
    Cpp_CvQualifier *cvQualifier;
    Cpp_CvQualifierSeq *cvQualifierSeq;

    Cpp_CvQualifierSeq ()
        : CppElement (CppElement::_CvQualifierSeq)
          , cvQualifier (NULL)
          , cvQualifierSeq (NULL)
    {
    }
};

void dump_cpp_CvQualifierSeq (Cpp_CvQualifierSeq const *, MyCpp::Size nest_level = 0);

class Cpp_CvQualifier : public CppElement
{
public:
    enum Type {
        _Const,
        _Volatile
    };

    const Type cv_qualifier_type;

    Cpp_CvQualifier (Type type)
        : CppElement (CppElement::_CvQualifier),
          cv_qualifier_type (type)
    {
    }
};

class Cpp_CvQualifier_Const : public Cpp_CvQualifier
{
public:

    Cpp_CvQualifier_Const ()
        : Cpp_CvQualifier (Cpp_CvQualifier::_Const)
    {
    }
};

class Cpp_CvQualifier_Volatile : public Cpp_CvQualifier
{
public:

    Cpp_CvQualifier_Volatile ()
        : Cpp_CvQualifier (Cpp_CvQualifier::_Volatile)
    {
    }
};

void dump_cpp_CvQualifier (Cpp_CvQualifier const *, MyCpp::Size nest_level = 0);

class Cpp_DeclaratorId : public CppElement
{
public:
    Cpp_IdExpression *idExpression;

    Cpp_DeclaratorId ()
        : CppElement (CppElement::_DeclaratorId)
          , idExpression (NULL)
    {
    }
};

void dump_cpp_DeclaratorId (Cpp_DeclaratorId const *, MyCpp::Size nest_level = 0);

bool cpp_accept_declaration (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_typeid (
        Cpp_TypeId *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TypeId : public CppElement
{
public:
    Cpp_TypeSpecifierSeq *typeSpecifierSeq;
    Cpp_Declarator *declarator;

    Cpp_TypeId ()
        : CppElement (CppElement::_TypeId)
          , typeSpecifierSeq (NULL)
          , declarator (NULL)
    {
    }
};

void dump_cpp_TypeId (Cpp_TypeId const *, MyCpp::Size nest_level = 0);

class Cpp_TypeSpecifierSeq : public CppElement
{
public:
    Cpp_TypeSpecifier *typeSpecifier;
    Cpp_TypeSpecifierSeq *typeSpecifierSeq;

    Cpp_TypeSpecifierSeq ()
        : CppElement (CppElement::_TypeSpecifierSeq)
          , typeSpecifier (NULL)
          , typeSpecifierSeq (NULL)
    {
    }
};

void dump_cpp_TypeSpecifierSeq (Cpp_TypeSpecifierSeq const *, MyCpp::Size nest_level = 0);

class Cpp_ParameterDeclarationClause : public CppElement
{
public:
    enum Type {
        _Ellipsis,
        _ParameterDeclarationList
    };

    const Type parameter_declaration_clause_type;

    Cpp_ParameterDeclarationClause (Type type)
        : CppElement (CppElement::_ParameterDeclarationClause),
          parameter_declaration_clause_type (type)
    {
    }
};

class Cpp_ParameterDeclarationClause_Ellipsis : public Cpp_ParameterDeclarationClause
{
public:
    Cpp_ParameterDeclarationList *parameterDeclarationList;

    Cpp_ParameterDeclarationClause_Ellipsis ()
        : Cpp_ParameterDeclarationClause (Cpp_ParameterDeclarationClause::_Ellipsis)
          , parameterDeclarationList (NULL)
    {
    }
};

class Cpp_ParameterDeclarationClause_ParameterDeclarationList : public Cpp_ParameterDeclarationClause
{
public:
    Cpp_ParameterDeclarationList *parameterDeclarationList;

    Cpp_ParameterDeclarationClause_ParameterDeclarationList ()
        : Cpp_ParameterDeclarationClause (Cpp_ParameterDeclarationClause::_ParameterDeclarationList)
          , parameterDeclarationList (NULL)
    {
    }
};

void dump_cpp_ParameterDeclarationClause (Cpp_ParameterDeclarationClause const *, MyCpp::Size nest_level = 0);

class Cpp_ParameterDeclarationList : public CppElement
{
public:
    enum Type {
        _ParameterDeclarationList,
        _ParameterDeclaration
    };

    const Type parameter_declaration_list_type;

    Cpp_ParameterDeclarationList (Type type)
        : CppElement (CppElement::_ParameterDeclarationList),
          parameter_declaration_list_type (type)
    {
    }
};

class Cpp_ParameterDeclarationList_ParameterDeclarationList : public Cpp_ParameterDeclarationList
{
public:
    Cpp_ParameterDeclaration *parameterDeclaration;
    Cpp_ParameterDeclarationList *parameterDeclarationList;

    Cpp_ParameterDeclarationList_ParameterDeclarationList ()
        : Cpp_ParameterDeclarationList (Cpp_ParameterDeclarationList::_ParameterDeclarationList)
          , parameterDeclaration (NULL)
          , parameterDeclarationList (NULL)
    {
    }
};

class Cpp_ParameterDeclarationList_ParameterDeclaration : public Cpp_ParameterDeclarationList
{
public:
    Cpp_ParameterDeclaration *parameterDeclaration;

    Cpp_ParameterDeclarationList_ParameterDeclaration ()
        : Cpp_ParameterDeclarationList (Cpp_ParameterDeclarationList::_ParameterDeclaration)
          , parameterDeclaration (NULL)
    {
    }
};

void dump_cpp_ParameterDeclarationList (Cpp_ParameterDeclarationList const *, MyCpp::Size nest_level = 0);

bool cpp_begin_parameter_declaration (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_parameter_declaration_declarator_assignment (
        Cpp_ParameterDeclaration *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ParameterDeclaration : public CppElement
{
public:
    enum Type {
        _DeclaratorAssignment,
        _Declarator
    };

    const Type parameter_declaration_type;

    Cpp_ParameterDeclaration (Type type)
        : CppElement (CppElement::_ParameterDeclaration),
          parameter_declaration_type (type)
    {
    }
};

bool cpp_begin_parameter_declaration (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_parameter_declaration_declarator_assignment (
        Cpp_ParameterDeclaration *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ParameterDeclaration_DeclaratorAssignment : public Cpp_ParameterDeclaration
{
public:
    Cpp_DeclSpecifierSeq *declSpecifierSeq;
    Cpp_Declarator *declarator;
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_ParameterDeclaration_DeclaratorAssignment ()
        : Cpp_ParameterDeclaration (Cpp_ParameterDeclaration::_DeclaratorAssignment)
          , declSpecifierSeq (NULL)
          , declarator (NULL)
          , assignmentExpression (NULL)
    {
    }
};

class Cpp_ParameterDeclaration_Declarator : public Cpp_ParameterDeclaration
{
public:
    Cpp_DeclSpecifierSeq *declSpecifierSeq;
    Cpp_Declarator *declarator;

    Cpp_ParameterDeclaration_Declarator ()
        : Cpp_ParameterDeclaration (Cpp_ParameterDeclaration::_Declarator)
          , declSpecifierSeq (NULL)
          , declarator (NULL)
    {
    }
};

void dump_cpp_ParameterDeclaration (Cpp_ParameterDeclaration const *, MyCpp::Size nest_level = 0);

bool cpp_function_definition_match_func (
        Cpp_FunctionDefinition *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_FunctionDefinition : public CppElement
{
public:
    enum Type {
        _FunctionBody,
        _FunctionTryBlock
    };

    const Type function_definition_type;

    Cpp_FunctionDefinition (Type type)
        : CppElement (CppElement::_FunctionDefinition),
          function_definition_type (type)
    {
    }
};

bool cpp_function_definition_match_func (
        Cpp_FunctionDefinition *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_FunctionDefinition_FunctionBody : public Cpp_FunctionDefinition
{
public:
    Cpp_DeclSpecifierSeq *declSpecifierSeq;
    Cpp_Declarator *declarator;
    Cpp_CtorInitializer *ctorInitializer;
    Cpp_FunctionBody *functionBody;

    Cpp_FunctionDefinition_FunctionBody ()
        : Cpp_FunctionDefinition (Cpp_FunctionDefinition::_FunctionBody)
          , declSpecifierSeq (NULL)
          , declarator (NULL)
          , ctorInitializer (NULL)
          , functionBody (NULL)
    {
    }
};

class Cpp_FunctionDefinition_FunctionTryBlock : public Cpp_FunctionDefinition
{
public:
    Cpp_DeclSpecifierSeq *declSpecifierSeq;
    Cpp_Declarator *declarator;
    Cpp_FunctionTryBlock *functionTryBlock;

    Cpp_FunctionDefinition_FunctionTryBlock ()
        : Cpp_FunctionDefinition (Cpp_FunctionDefinition::_FunctionTryBlock)
          , declSpecifierSeq (NULL)
          , declarator (NULL)
          , functionTryBlock (NULL)
    {
    }
};

void dump_cpp_FunctionDefinition (Cpp_FunctionDefinition const *, MyCpp::Size nest_level = 0);

class Cpp_FunctionBody : public CppElement
{
public:
    enum Type {
        _Default,
        _ClassPrematch
    };

    const Type function_body_type;

    Cpp_FunctionBody (Type type)
        : CppElement (CppElement::_FunctionBody),
          function_body_type (type)
    {
    }
};

class Cpp_FunctionBody_Default : public Cpp_FunctionBody
{
public:
    Cpp_CompoundStatement *compoundStatement;

    Cpp_FunctionBody_Default ()
        : Cpp_FunctionBody (Cpp_FunctionBody::_Default)
          , compoundStatement (NULL)
    {
    }
};

class Cpp_FunctionBody_ClassPrematch : public Cpp_FunctionBody
{
public:
    Cpp_Scruffy_SkipCompoundStatement *scruffy_SkipCompoundStatement;

    Cpp_FunctionBody_ClassPrematch ()
        : Cpp_FunctionBody (Cpp_FunctionBody::_ClassPrematch)
          , scruffy_SkipCompoundStatement (NULL)
    {
    }
};

void dump_cpp_FunctionBody (Cpp_FunctionBody const *, MyCpp::Size nest_level = 0);

bool cpp_accept_initializer (
        Cpp_Initializer *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_Initializer : public CppElement
{
public:
    enum Type {
        _InitializerClause,
        _ExpressionList
    };

    const Type initializer_type;

    Cpp_Initializer (Type type)
        : CppElement (CppElement::_Initializer),
          initializer_type (type)
    {
    }
};

bool cpp_accept_initializer (
        Cpp_Initializer *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_Initializer_InitializerClause : public Cpp_Initializer
{
public:
    Cpp_InitializerClause *initializerClause;

    Cpp_Initializer_InitializerClause ()
        : Cpp_Initializer (Cpp_Initializer::_InitializerClause)
          , initializerClause (NULL)
    {
    }
};

class Cpp_Initializer_ExpressionList : public Cpp_Initializer
{
public:
    Cpp_ExpressionList *expressionList;

    Cpp_Initializer_ExpressionList ()
        : Cpp_Initializer (Cpp_Initializer::_ExpressionList)
          , expressionList (NULL)
    {
    }
};

void dump_cpp_Initializer (Cpp_Initializer const *, MyCpp::Size nest_level = 0);

class Cpp_InitializerClause : public CppElement
{
public:
    enum Type {
        _Expression,
        _InitializerList
    };

    const Type initializer_clause_type;

    Cpp_InitializerClause (Type type)
        : CppElement (CppElement::_InitializerClause),
          initializer_clause_type (type)
    {
    }
};

class Cpp_InitializerClause_Expression : public Cpp_InitializerClause
{
public:
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_InitializerClause_Expression ()
        : Cpp_InitializerClause (Cpp_InitializerClause::_Expression)
          , assignmentExpression (NULL)
    {
    }
};

class Cpp_InitializerClause_InitializerList : public Cpp_InitializerClause
{
public:
    Cpp_InitializerList *initializerList;

    Cpp_InitializerClause_InitializerList ()
        : Cpp_InitializerClause (Cpp_InitializerClause::_InitializerList)
          , initializerList (NULL)
    {
    }
};

void dump_cpp_InitializerClause (Cpp_InitializerClause const *, MyCpp::Size nest_level = 0);

class Cpp_InitializerList : public CppElement
{
public:
    enum Type {
        _InitializerClause,
        _InitializerList
    };

    const Type initializer_list_type;

    Cpp_InitializerList (Type type)
        : CppElement (CppElement::_InitializerList),
          initializer_list_type (type)
    {
    }
};

class Cpp_InitializerList_InitializerClause : public Cpp_InitializerList
{
public:
    Cpp_InitializerClause *initializerClause;

    Cpp_InitializerList_InitializerClause ()
        : Cpp_InitializerList (Cpp_InitializerList::_InitializerClause)
          , initializerClause (NULL)
    {
    }
};

class Cpp_InitializerList_InitializerList : public Cpp_InitializerList
{
public:
    Cpp_InitializerClause *initializerClause;
    Cpp_InitializerList *initializerList;

    Cpp_InitializerList_InitializerList ()
        : Cpp_InitializerList (Cpp_InitializerList::_InitializerList)
          , initializerClause (NULL)
          , initializerList (NULL)
    {
    }
};

void dump_cpp_InitializerList (Cpp_InitializerList const *, MyCpp::Size nest_level = 0);

class Cpp_ClassName : public CppElement
{
public:
    enum Type {
        _ClassNameIdentifier,
        _TemplateId
    };

    const Type class_name_type;

    Cpp_ClassName (Type type)
        : CppElement (CppElement::_ClassName),
          class_name_type (type)
    {
    }
};

class Cpp_ClassName_ClassNameIdentifier : public Cpp_ClassName
{
public:
    Cpp_ClassNameIdentifier *classNameIdentifier;

    Cpp_ClassName_ClassNameIdentifier ()
        : Cpp_ClassName (Cpp_ClassName::_ClassNameIdentifier)
          , classNameIdentifier (NULL)
    {
    }
};

class Cpp_ClassName_TemplateId : public Cpp_ClassName
{
public:
    Cpp_TemplateId *templateId;

    Cpp_ClassName_TemplateId ()
        : Cpp_ClassName (Cpp_ClassName::_TemplateId)
          , templateId (NULL)
    {
    }
};

void dump_cpp_ClassName (Cpp_ClassName const *, MyCpp::Size nest_level = 0);

class Cpp_ClassNameIdentifier : public CppElement
{
public:
    Cpp_Identifier *identifier;

    Cpp_ClassNameIdentifier ()
        : CppElement (CppElement::_ClassNameIdentifier)
          , identifier (NULL)
    {
    }
};

void dump_cpp_ClassNameIdentifier (Cpp_ClassNameIdentifier const *, MyCpp::Size nest_level = 0);

bool cpp_accept_class_head (
        Cpp_ClassSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_begin_class_definition (
        Cpp_ClassSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_class_definition (
        Cpp_ClassSpecifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ClassSpecifier : public CppElement
{
public:
    Cpp_ClassHead *classHead;
    Cpp_MemberSpecification *memberSpecification;

    Cpp_ClassSpecifier ()
        : CppElement (CppElement::_ClassSpecifier)
          , classHead (NULL)
          , memberSpecification (NULL)
    {
    }
};

void dump_cpp_ClassSpecifier (Cpp_ClassSpecifier const *, MyCpp::Size nest_level = 0);

bool cpp_accept_class_identifier (
        Cpp_ClassHead *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ClassHead : public CppElement
{
public:
    enum Type {
        _Simple,
        _NestedNameSpecifier,
        _TemplateId
    };

    const Type class_head_type;

    Cpp_ClassHead (Type type)
        : CppElement (CppElement::_ClassHead),
          class_head_type (type)
    {
    }
};

bool cpp_accept_class_identifier (
        Cpp_ClassHead *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ClassHead_Simple : public Cpp_ClassHead
{
public:
    Cpp_ClassKey *classKey;
    Cpp_Identifier *identifier;
    Cpp_BaseClause *baseClause;

    Cpp_ClassHead_Simple ()
        : Cpp_ClassHead (Cpp_ClassHead::_Simple)
          , classKey (NULL)
          , identifier (NULL)
          , baseClause (NULL)
    {
    }
};

class Cpp_ClassHead_NestedNameSpecifier : public Cpp_ClassHead
{
public:
    Cpp_ClassKey *classKey;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_Identifier *identifier;
    Cpp_BaseClause *baseClause;

    Cpp_ClassHead_NestedNameSpecifier ()
        : Cpp_ClassHead (Cpp_ClassHead::_NestedNameSpecifier)
          , classKey (NULL)
          , nestedNameSpecifier (NULL)
          , identifier (NULL)
          , baseClause (NULL)
    {
    }
};

class Cpp_ClassHead_TemplateId : public Cpp_ClassHead
{
public:
    Cpp_ClassKey *classKey;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_TemplateId *templateId;
    Cpp_BaseClause *baseClause;

    Cpp_ClassHead_TemplateId ()
        : Cpp_ClassHead (Cpp_ClassHead::_TemplateId)
          , classKey (NULL)
          , nestedNameSpecifier (NULL)
          , templateId (NULL)
          , baseClause (NULL)
    {
    }
};

void dump_cpp_ClassHead (Cpp_ClassHead const *, MyCpp::Size nest_level = 0);

class Cpp_ClassKey : public CppElement
{
public:
    enum Type {
        _Class,
        _Struct,
        _Union
    };

    const Type class_key_type;

    Cpp_ClassKey (Type type)
        : CppElement (CppElement::_ClassKey),
          class_key_type (type)
    {
    }
};

class Cpp_ClassKey_Class : public Cpp_ClassKey
{
public:

    Cpp_ClassKey_Class ()
        : Cpp_ClassKey (Cpp_ClassKey::_Class)
    {
    }
};

class Cpp_ClassKey_Struct : public Cpp_ClassKey
{
public:

    Cpp_ClassKey_Struct ()
        : Cpp_ClassKey (Cpp_ClassKey::_Struct)
    {
    }
};

class Cpp_ClassKey_Union : public Cpp_ClassKey
{
public:

    Cpp_ClassKey_Union ()
        : Cpp_ClassKey (Cpp_ClassKey::_Union)
    {
    }
};

void dump_cpp_ClassKey (Cpp_ClassKey const *, MyCpp::Size nest_level = 0);

class Cpp_MemberSpecification : public CppElement
{
public:
    enum Type {
        _MemberDeclaration,
        _AccessSpecifier
    };

    const Type member_specification_type;

    Cpp_MemberSpecification (Type type)
        : CppElement (CppElement::_MemberSpecification),
          member_specification_type (type)
    {
    }
};

class Cpp_MemberSpecification_MemberDeclaration : public Cpp_MemberSpecification
{
public:
    Cpp_MemberDeclaration *memberDeclaration;
    Cpp_MemberSpecification *memberSpecification;

    Cpp_MemberSpecification_MemberDeclaration ()
        : Cpp_MemberSpecification (Cpp_MemberSpecification::_MemberDeclaration)
          , memberDeclaration (NULL)
          , memberSpecification (NULL)
    {
    }
};

class Cpp_MemberSpecification_AccessSpecifier : public Cpp_MemberSpecification
{
public:
    Cpp_AccessSpecifier *accessSpecifier;
    Cpp_MemberSpecification *memberSpecification;

    Cpp_MemberSpecification_AccessSpecifier ()
        : Cpp_MemberSpecification (Cpp_MemberSpecification::_AccessSpecifier)
          , accessSpecifier (NULL)
          , memberSpecification (NULL)
    {
    }
};

void dump_cpp_MemberSpecification (Cpp_MemberSpecification const *, MyCpp::Size nest_level = 0);

class Cpp_MemberDeclaration : public CppElement
{
public:
    enum Type {
        _MemberDeclaratorList,
        _FunctionDefinition,
        _NestedNameSpecifier,
        _UsingDeclaration,
        _TemplateDeclaration
    };

    const Type member_declaration_type;

    Cpp_MemberDeclaration (Type type)
        : CppElement (CppElement::_MemberDeclaration),
          member_declaration_type (type)
    {
    }
};

class Cpp_MemberDeclaration_MemberDeclaratorList : public Cpp_MemberDeclaration
{
public:
    Cpp_DeclSpecifierSeq *declSpecifierSeq;
    Cpp_MemberDeclaratorList *memberDeclaratorList;

    Cpp_MemberDeclaration_MemberDeclaratorList ()
        : Cpp_MemberDeclaration (Cpp_MemberDeclaration::_MemberDeclaratorList)
          , declSpecifierSeq (NULL)
          , memberDeclaratorList (NULL)
    {
    }
};

class Cpp_MemberDeclaration_FunctionDefinition : public Cpp_MemberDeclaration
{
public:
    Cpp_FunctionDefinition *functionDefinition;

    Cpp_MemberDeclaration_FunctionDefinition ()
        : Cpp_MemberDeclaration (Cpp_MemberDeclaration::_FunctionDefinition)
          , functionDefinition (NULL)
    {
    }
};

class Cpp_MemberDeclaration_NestedNameSpecifier : public Cpp_MemberDeclaration
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_UnqualifiedId *unqualifiedId;

    Cpp_MemberDeclaration_NestedNameSpecifier ()
        : Cpp_MemberDeclaration (Cpp_MemberDeclaration::_NestedNameSpecifier)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , unqualifiedId (NULL)
    {
    }
};

class Cpp_MemberDeclaration_UsingDeclaration : public Cpp_MemberDeclaration
{
public:
    Cpp_UsingDeclaration *usingDeclaration;

    Cpp_MemberDeclaration_UsingDeclaration ()
        : Cpp_MemberDeclaration (Cpp_MemberDeclaration::_UsingDeclaration)
          , usingDeclaration (NULL)
    {
    }
};

class Cpp_MemberDeclaration_TemplateDeclaration : public Cpp_MemberDeclaration
{
public:
    Cpp_TemplateDeclaration *templateDeclaration;

    Cpp_MemberDeclaration_TemplateDeclaration ()
        : Cpp_MemberDeclaration (Cpp_MemberDeclaration::_TemplateDeclaration)
          , templateDeclaration (NULL)
    {
    }
};

void dump_cpp_MemberDeclaration (Cpp_MemberDeclaration const *, MyCpp::Size nest_level = 0);

class Cpp_MemberDeclaratorList : public CppElement
{
public:
    enum Type {
        _MemberDeclaratorList,
        _MemberDeclarator
    };

    const Type member_declarator_list_type;

    Cpp_MemberDeclaratorList (Type type)
        : CppElement (CppElement::_MemberDeclaratorList),
          member_declarator_list_type (type)
    {
    }
};

class Cpp_MemberDeclaratorList_MemberDeclaratorList : public Cpp_MemberDeclaratorList
{
public:
    Cpp_MemberDeclarator *memberDeclarator;
    Cpp_MemberDeclaratorList *memberDeclaratorList;

    Cpp_MemberDeclaratorList_MemberDeclaratorList ()
        : Cpp_MemberDeclaratorList (Cpp_MemberDeclaratorList::_MemberDeclaratorList)
          , memberDeclarator (NULL)
          , memberDeclaratorList (NULL)
    {
    }
};

class Cpp_MemberDeclaratorList_MemberDeclarator : public Cpp_MemberDeclaratorList
{
public:
    Cpp_MemberDeclarator *memberDeclarator;

    Cpp_MemberDeclaratorList_MemberDeclarator ()
        : Cpp_MemberDeclaratorList (Cpp_MemberDeclaratorList::_MemberDeclarator)
          , memberDeclarator (NULL)
    {
    }
};

void dump_cpp_MemberDeclaratorList (Cpp_MemberDeclaratorList const *, MyCpp::Size nest_level = 0);

class Cpp_MemberDeclarator : public CppElement
{
public:
    enum Type {
        _PureSpecifier,
        _ConstantInitializer,
        _Bitfield
    };

    const Type member_declarator_type;

    Cpp_MemberDeclarator (Type type)
        : CppElement (CppElement::_MemberDeclarator),
          member_declarator_type (type)
    {
    }
};

class Cpp_MemberDeclarator_PureSpecifier : public Cpp_MemberDeclarator
{
public:
    Cpp_Declarator *declarator;
    Cpp_PureSpecifier *pureSpecifier;

    Cpp_MemberDeclarator_PureSpecifier ()
        : Cpp_MemberDeclarator (Cpp_MemberDeclarator::_PureSpecifier)
          , declarator (NULL)
          , pureSpecifier (NULL)
    {
    }
};

class Cpp_MemberDeclarator_ConstantInitializer : public Cpp_MemberDeclarator
{
public:
    Cpp_Declarator *declarator;
    Cpp_ConstantInitializer *constantInitializer;

    Cpp_MemberDeclarator_ConstantInitializer ()
        : Cpp_MemberDeclarator (Cpp_MemberDeclarator::_ConstantInitializer)
          , declarator (NULL)
          , constantInitializer (NULL)
    {
    }
};

class Cpp_MemberDeclarator_Bitfield : public Cpp_MemberDeclarator
{
public:
    Cpp_Identifier *identifier;
    Cpp_ConstantExpression *constantExpression;

    Cpp_MemberDeclarator_Bitfield ()
        : Cpp_MemberDeclarator (Cpp_MemberDeclarator::_Bitfield)
          , identifier (NULL)
          , constantExpression (NULL)
    {
    }
};

void dump_cpp_MemberDeclarator (Cpp_MemberDeclarator const *, MyCpp::Size nest_level = 0);

class Cpp_PureSpecifier : public CppElement
{
public:

    Cpp_PureSpecifier ()
        : CppElement (CppElement::_PureSpecifier)
    {
    }
};

void dump_cpp_PureSpecifier (Cpp_PureSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_ConstantInitializer : public CppElement
{
public:
    Cpp_ConstantExpression *constantExpression;

    Cpp_ConstantInitializer ()
        : CppElement (CppElement::_ConstantInitializer)
          , constantExpression (NULL)
    {
    }
};

void dump_cpp_ConstantInitializer (Cpp_ConstantInitializer const *, MyCpp::Size nest_level = 0);

class Cpp_BaseClause : public CppElement
{
public:
    Cpp_BaseSpecifierList *baseSpecifierList;

    Cpp_BaseClause ()
        : CppElement (CppElement::_BaseClause)
          , baseSpecifierList (NULL)
    {
    }
};

void dump_cpp_BaseClause (Cpp_BaseClause const *, MyCpp::Size nest_level = 0);

class Cpp_BaseSpecifierList : public CppElement
{
public:
    enum Type {
        _BaseSpecifierList,
        _BaseSpecifier
    };

    const Type base_specifier_list_type;

    Cpp_BaseSpecifierList (Type type)
        : CppElement (CppElement::_BaseSpecifierList),
          base_specifier_list_type (type)
    {
    }
};

class Cpp_BaseSpecifierList_BaseSpecifierList : public Cpp_BaseSpecifierList
{
public:
    Cpp_BaseSpecifier *baseSpecifier;
    Cpp_BaseSpecifierList *baseSpecifierList;

    Cpp_BaseSpecifierList_BaseSpecifierList ()
        : Cpp_BaseSpecifierList (Cpp_BaseSpecifierList::_BaseSpecifierList)
          , baseSpecifier (NULL)
          , baseSpecifierList (NULL)
    {
    }
};

class Cpp_BaseSpecifierList_BaseSpecifier : public Cpp_BaseSpecifierList
{
public:
    Cpp_BaseSpecifier *baseSpecifier;

    Cpp_BaseSpecifierList_BaseSpecifier ()
        : Cpp_BaseSpecifierList (Cpp_BaseSpecifierList::_BaseSpecifier)
          , baseSpecifier (NULL)
    {
    }
};

void dump_cpp_BaseSpecifierList (Cpp_BaseSpecifierList const *, MyCpp::Size nest_level = 0);

class Cpp_BaseSpecifier : public CppElement
{
public:
    enum Type {
        _Base,
        _Virtual,
        _AccessSpecifier
    };

    const Type base_specifier_type;

    Cpp_BaseSpecifier (Type type)
        : CppElement (CppElement::_BaseSpecifier),
          base_specifier_type (type)
    {
    }
};

class Cpp_BaseSpecifier_Base : public Cpp_BaseSpecifier
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_ClassName *className;

    Cpp_BaseSpecifier_Base ()
        : Cpp_BaseSpecifier (Cpp_BaseSpecifier::_Base)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , className (NULL)
    {
    }
};

class Cpp_BaseSpecifier_Virtual : public Cpp_BaseSpecifier
{
public:
    Cpp_AccessSpecifier *accessSpecifier;
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_ClassName *className;

    Cpp_BaseSpecifier_Virtual ()
        : Cpp_BaseSpecifier (Cpp_BaseSpecifier::_Virtual)
          , accessSpecifier (NULL)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , className (NULL)
    {
    }
};

class Cpp_BaseSpecifier_AccessSpecifier : public Cpp_BaseSpecifier
{
public:
    Cpp_AccessSpecifier *accessSpecifier;
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_ClassName *className;

    Cpp_BaseSpecifier_AccessSpecifier ()
        : Cpp_BaseSpecifier (Cpp_BaseSpecifier::_AccessSpecifier)
          , accessSpecifier (NULL)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , className (NULL)
    {
    }
};

void dump_cpp_BaseSpecifier (Cpp_BaseSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_AccessSpecifier : public CppElement
{
public:
    enum Type {
        _Private,
        _Protected,
        _Public
    };

    const Type access_specifier_type;

    Cpp_AccessSpecifier (Type type)
        : CppElement (CppElement::_AccessSpecifier),
          access_specifier_type (type)
    {
    }
};

class Cpp_AccessSpecifier_Private : public Cpp_AccessSpecifier
{
public:

    Cpp_AccessSpecifier_Private ()
        : Cpp_AccessSpecifier (Cpp_AccessSpecifier::_Private)
    {
    }
};

class Cpp_AccessSpecifier_Protected : public Cpp_AccessSpecifier
{
public:

    Cpp_AccessSpecifier_Protected ()
        : Cpp_AccessSpecifier (Cpp_AccessSpecifier::_Protected)
    {
    }
};

class Cpp_AccessSpecifier_Public : public Cpp_AccessSpecifier
{
public:

    Cpp_AccessSpecifier_Public ()
        : Cpp_AccessSpecifier (Cpp_AccessSpecifier::_Public)
    {
    }
};

void dump_cpp_AccessSpecifier (Cpp_AccessSpecifier const *, MyCpp::Size nest_level = 0);

class Cpp_ConversionFunctionId : public CppElement
{
public:
    Cpp_ConversionTypeId *conversionTypeId;

    Cpp_ConversionFunctionId ()
        : CppElement (CppElement::_ConversionFunctionId)
          , conversionTypeId (NULL)
    {
    }
};

void dump_cpp_ConversionFunctionId (Cpp_ConversionFunctionId const *, MyCpp::Size nest_level = 0);

class Cpp_ConversionTypeId : public CppElement
{
public:
    Cpp_TypeSpecifierSeq *typeSpecifierSeq;
    Cpp_ConversionDeclarator *conversionDeclarator;

    Cpp_ConversionTypeId ()
        : CppElement (CppElement::_ConversionTypeId)
          , typeSpecifierSeq (NULL)
          , conversionDeclarator (NULL)
    {
    }
};

void dump_cpp_ConversionTypeId (Cpp_ConversionTypeId const *, MyCpp::Size nest_level = 0);

class Cpp_ConversionDeclarator : public CppElement
{
public:
    Cpp_PtrOperator *ptrOperator;
    Cpp_ConversionDeclarator *conversionDeclarator;

    Cpp_ConversionDeclarator ()
        : CppElement (CppElement::_ConversionDeclarator)
          , ptrOperator (NULL)
          , conversionDeclarator (NULL)
    {
    }
};

void dump_cpp_ConversionDeclarator (Cpp_ConversionDeclarator const *, MyCpp::Size nest_level = 0);

class Cpp_CtorInitializer : public CppElement
{
public:
    Cpp_MemInitializerList *memInitializerList;

    Cpp_CtorInitializer ()
        : CppElement (CppElement::_CtorInitializer)
          , memInitializerList (NULL)
    {
    }
};

void dump_cpp_CtorInitializer (Cpp_CtorInitializer const *, MyCpp::Size nest_level = 0);

class Cpp_MemInitializerList : public CppElement
{
public:
    enum Type {
        _List,
        _MemInitializer
    };

    const Type mem_initializer_list_type;

    Cpp_MemInitializerList (Type type)
        : CppElement (CppElement::_MemInitializerList),
          mem_initializer_list_type (type)
    {
    }
};

class Cpp_MemInitializerList_List : public Cpp_MemInitializerList
{
public:
    Cpp_MemInitializer *memInitializer;
    Cpp_MemInitializerList *memInitializerList;

    Cpp_MemInitializerList_List ()
        : Cpp_MemInitializerList (Cpp_MemInitializerList::_List)
          , memInitializer (NULL)
          , memInitializerList (NULL)
    {
    }
};

class Cpp_MemInitializerList_MemInitializer : public Cpp_MemInitializerList
{
public:
    Cpp_MemInitializer *memInitializer;

    Cpp_MemInitializerList_MemInitializer ()
        : Cpp_MemInitializerList (Cpp_MemInitializerList::_MemInitializer)
          , memInitializer (NULL)
    {
    }
};

void dump_cpp_MemInitializerList (Cpp_MemInitializerList const *, MyCpp::Size nest_level = 0);

bool cpp_MemInitializer_accept_func (
        Cpp_MemInitializer *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_MemInitializer : public CppElement
{
public:
    enum Type {
        _Default,
        _ClassPrematch
    };

    const Type mem_initializer_type;

    Cpp_MemInitializer (Type type)
        : CppElement (CppElement::_MemInitializer),
          mem_initializer_type (type)
    {
    }
};

bool cpp_MemInitializer_accept_func (
        Cpp_MemInitializer *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_MemInitializer_Default : public Cpp_MemInitializer
{
public:
    Cpp_MemInitializerId *memInitializerId;
    Cpp_ExpressionList *expressionList;

    Cpp_MemInitializer_Default ()
        : Cpp_MemInitializer (Cpp_MemInitializer::_Default)
          , memInitializerId (NULL)
          , expressionList (NULL)
    {
    }
};

class Cpp_MemInitializer_ClassPrematch : public Cpp_MemInitializer
{
public:
    MyCpp::List<Cpp_Scruffy_NotAParenthesis*> scruffy_NotAParenthesiss;
    Cpp_Scruffy_SkipExpressionList *scruffy_SkipExpressionList;

    Cpp_MemInitializer_ClassPrematch ()
        : Cpp_MemInitializer (Cpp_MemInitializer::_ClassPrematch)
          , scruffy_SkipExpressionList (NULL)
    {
    }
};

void dump_cpp_MemInitializer (Cpp_MemInitializer const *, MyCpp::Size nest_level = 0);

class Cpp_MemInitializerId : public CppElement
{
public:
    enum Type {
        _ClassName,
        _Identifier
    };

    const Type mem_initializer_id_type;

    Cpp_MemInitializerId (Type type)
        : CppElement (CppElement::_MemInitializerId),
          mem_initializer_id_type (type)
    {
    }
};

class Cpp_MemInitializerId_ClassName : public Cpp_MemInitializerId
{
public:
    Cpp_Scruffy_GlobalScope *scruffy_GlobalScope;
    Cpp_NestedNameSpecifier *nestedNameSpecifier;
    Cpp_ClassName *className;

    Cpp_MemInitializerId_ClassName ()
        : Cpp_MemInitializerId (Cpp_MemInitializerId::_ClassName)
          , scruffy_GlobalScope (NULL)
          , nestedNameSpecifier (NULL)
          , className (NULL)
    {
    }
};

class Cpp_MemInitializerId_Identifier : public Cpp_MemInitializerId
{
public:
    Cpp_Identifier *identifier;

    Cpp_MemInitializerId_Identifier ()
        : Cpp_MemInitializerId (Cpp_MemInitializerId::_Identifier)
          , identifier (NULL)
    {
    }
};

void dump_cpp_MemInitializerId (Cpp_MemInitializerId const *, MyCpp::Size nest_level = 0);

class Cpp_OperatorFunctionId : public CppElement
{
public:
    Cpp_Operator *_operator;

    Cpp_OperatorFunctionId ()
        : CppElement (CppElement::_OperatorFunctionId)
          , _operator (NULL)
    {
    }
};

void dump_cpp_OperatorFunctionId (Cpp_OperatorFunctionId const *, MyCpp::Size nest_level = 0);

class Cpp_Operator : public CppElement
{
public:
    enum Type {
        _New,
        _Delete,
        _NewArray,
        _DeleteArray,
        _Plus,
        _Minus,
        _Multiply,
        _Divide,
        _Remainder,
        _ExclusiveOr,
        _And,
        _InclusiveOr,
        _Inversion,
        _Not,
        _Set,
        _Less,
        _Greater,
        _PlusSet,
        _MinusSet,
        _MultiplySet,
        _DivideSet,
        _RemainderSet,
        _ExclusiveOrSet,
        _AndSet,
        _InclusiveOrSet,
        _LeftShift,
        _RightShift,
        _RightShiftSet,
        _LeftShiftSet,
        _Equal,
        _NotEqual,
        _LessOrEqual,
        _GreaterOrEqual,
        _LogicalAnd,
        _LogicalOr,
        _Increment,
        _Decrement,
        _Comma,
        _MemberDereference,
        _Dereference,
        _FunctionCall,
        _Subscripting
    };

    const Type operator_type;

    Cpp_Operator (Type type)
        : CppElement (CppElement::_Operator),
          operator_type (type)
    {
    }
};

class Cpp_Operator_New : public Cpp_Operator
{
public:

    Cpp_Operator_New ()
        : Cpp_Operator (Cpp_Operator::_New)
    {
    }
};

class Cpp_Operator_Delete : public Cpp_Operator
{
public:

    Cpp_Operator_Delete ()
        : Cpp_Operator (Cpp_Operator::_Delete)
    {
    }
};

class Cpp_Operator_NewArray : public Cpp_Operator
{
public:

    Cpp_Operator_NewArray ()
        : Cpp_Operator (Cpp_Operator::_NewArray)
    {
    }
};

class Cpp_Operator_DeleteArray : public Cpp_Operator
{
public:

    Cpp_Operator_DeleteArray ()
        : Cpp_Operator (Cpp_Operator::_DeleteArray)
    {
    }
};

class Cpp_Operator_Plus : public Cpp_Operator
{
public:

    Cpp_Operator_Plus ()
        : Cpp_Operator (Cpp_Operator::_Plus)
    {
    }
};

class Cpp_Operator_Minus : public Cpp_Operator
{
public:

    Cpp_Operator_Minus ()
        : Cpp_Operator (Cpp_Operator::_Minus)
    {
    }
};

class Cpp_Operator_Multiply : public Cpp_Operator
{
public:

    Cpp_Operator_Multiply ()
        : Cpp_Operator (Cpp_Operator::_Multiply)
    {
    }
};

class Cpp_Operator_Divide : public Cpp_Operator
{
public:

    Cpp_Operator_Divide ()
        : Cpp_Operator (Cpp_Operator::_Divide)
    {
    }
};

class Cpp_Operator_Remainder : public Cpp_Operator
{
public:

    Cpp_Operator_Remainder ()
        : Cpp_Operator (Cpp_Operator::_Remainder)
    {
    }
};

class Cpp_Operator_ExclusiveOr : public Cpp_Operator
{
public:

    Cpp_Operator_ExclusiveOr ()
        : Cpp_Operator (Cpp_Operator::_ExclusiveOr)
    {
    }
};

class Cpp_Operator_And : public Cpp_Operator
{
public:

    Cpp_Operator_And ()
        : Cpp_Operator (Cpp_Operator::_And)
    {
    }
};

class Cpp_Operator_InclusiveOr : public Cpp_Operator
{
public:

    Cpp_Operator_InclusiveOr ()
        : Cpp_Operator (Cpp_Operator::_InclusiveOr)
    {
    }
};

class Cpp_Operator_Inversion : public Cpp_Operator
{
public:

    Cpp_Operator_Inversion ()
        : Cpp_Operator (Cpp_Operator::_Inversion)
    {
    }
};

class Cpp_Operator_Not : public Cpp_Operator
{
public:

    Cpp_Operator_Not ()
        : Cpp_Operator (Cpp_Operator::_Not)
    {
    }
};

class Cpp_Operator_Set : public Cpp_Operator
{
public:

    Cpp_Operator_Set ()
        : Cpp_Operator (Cpp_Operator::_Set)
    {
    }
};

class Cpp_Operator_Less : public Cpp_Operator
{
public:

    Cpp_Operator_Less ()
        : Cpp_Operator (Cpp_Operator::_Less)
    {
    }
};

class Cpp_Operator_Greater : public Cpp_Operator
{
public:

    Cpp_Operator_Greater ()
        : Cpp_Operator (Cpp_Operator::_Greater)
    {
    }
};

class Cpp_Operator_PlusSet : public Cpp_Operator
{
public:

    Cpp_Operator_PlusSet ()
        : Cpp_Operator (Cpp_Operator::_PlusSet)
    {
    }
};

class Cpp_Operator_MinusSet : public Cpp_Operator
{
public:

    Cpp_Operator_MinusSet ()
        : Cpp_Operator (Cpp_Operator::_MinusSet)
    {
    }
};

class Cpp_Operator_MultiplySet : public Cpp_Operator
{
public:

    Cpp_Operator_MultiplySet ()
        : Cpp_Operator (Cpp_Operator::_MultiplySet)
    {
    }
};

class Cpp_Operator_DivideSet : public Cpp_Operator
{
public:

    Cpp_Operator_DivideSet ()
        : Cpp_Operator (Cpp_Operator::_DivideSet)
    {
    }
};

class Cpp_Operator_RemainderSet : public Cpp_Operator
{
public:

    Cpp_Operator_RemainderSet ()
        : Cpp_Operator (Cpp_Operator::_RemainderSet)
    {
    }
};

class Cpp_Operator_ExclusiveOrSet : public Cpp_Operator
{
public:

    Cpp_Operator_ExclusiveOrSet ()
        : Cpp_Operator (Cpp_Operator::_ExclusiveOrSet)
    {
    }
};

class Cpp_Operator_AndSet : public Cpp_Operator
{
public:

    Cpp_Operator_AndSet ()
        : Cpp_Operator (Cpp_Operator::_AndSet)
    {
    }
};

class Cpp_Operator_InclusiveOrSet : public Cpp_Operator
{
public:

    Cpp_Operator_InclusiveOrSet ()
        : Cpp_Operator (Cpp_Operator::_InclusiveOrSet)
    {
    }
};

class Cpp_Operator_LeftShift : public Cpp_Operator
{
public:

    Cpp_Operator_LeftShift ()
        : Cpp_Operator (Cpp_Operator::_LeftShift)
    {
    }
};

class Cpp_Operator_RightShift : public Cpp_Operator
{
public:

    Cpp_Operator_RightShift ()
        : Cpp_Operator (Cpp_Operator::_RightShift)
    {
    }
};

class Cpp_Operator_RightShiftSet : public Cpp_Operator
{
public:

    Cpp_Operator_RightShiftSet ()
        : Cpp_Operator (Cpp_Operator::_RightShiftSet)
    {
    }
};

class Cpp_Operator_LeftShiftSet : public Cpp_Operator
{
public:

    Cpp_Operator_LeftShiftSet ()
        : Cpp_Operator (Cpp_Operator::_LeftShiftSet)
    {
    }
};

class Cpp_Operator_Equal : public Cpp_Operator
{
public:

    Cpp_Operator_Equal ()
        : Cpp_Operator (Cpp_Operator::_Equal)
    {
    }
};

class Cpp_Operator_NotEqual : public Cpp_Operator
{
public:

    Cpp_Operator_NotEqual ()
        : Cpp_Operator (Cpp_Operator::_NotEqual)
    {
    }
};

class Cpp_Operator_LessOrEqual : public Cpp_Operator
{
public:

    Cpp_Operator_LessOrEqual ()
        : Cpp_Operator (Cpp_Operator::_LessOrEqual)
    {
    }
};

class Cpp_Operator_GreaterOrEqual : public Cpp_Operator
{
public:

    Cpp_Operator_GreaterOrEqual ()
        : Cpp_Operator (Cpp_Operator::_GreaterOrEqual)
    {
    }
};

class Cpp_Operator_LogicalAnd : public Cpp_Operator
{
public:

    Cpp_Operator_LogicalAnd ()
        : Cpp_Operator (Cpp_Operator::_LogicalAnd)
    {
    }
};

class Cpp_Operator_LogicalOr : public Cpp_Operator
{
public:

    Cpp_Operator_LogicalOr ()
        : Cpp_Operator (Cpp_Operator::_LogicalOr)
    {
    }
};

class Cpp_Operator_Increment : public Cpp_Operator
{
public:

    Cpp_Operator_Increment ()
        : Cpp_Operator (Cpp_Operator::_Increment)
    {
    }
};

class Cpp_Operator_Decrement : public Cpp_Operator
{
public:

    Cpp_Operator_Decrement ()
        : Cpp_Operator (Cpp_Operator::_Decrement)
    {
    }
};

class Cpp_Operator_Comma : public Cpp_Operator
{
public:

    Cpp_Operator_Comma ()
        : Cpp_Operator (Cpp_Operator::_Comma)
    {
    }
};

class Cpp_Operator_MemberDereference : public Cpp_Operator
{
public:

    Cpp_Operator_MemberDereference ()
        : Cpp_Operator (Cpp_Operator::_MemberDereference)
    {
    }
};

class Cpp_Operator_Dereference : public Cpp_Operator
{
public:

    Cpp_Operator_Dereference ()
        : Cpp_Operator (Cpp_Operator::_Dereference)
    {
    }
};

class Cpp_Operator_FunctionCall : public Cpp_Operator
{
public:

    Cpp_Operator_FunctionCall ()
        : Cpp_Operator (Cpp_Operator::_FunctionCall)
    {
    }
};

class Cpp_Operator_Subscripting : public Cpp_Operator
{
public:

    Cpp_Operator_Subscripting ()
        : Cpp_Operator (Cpp_Operator::_Subscripting)
    {
    }
};

void dump_cpp_Operator (Cpp_Operator const *, MyCpp::Size nest_level = 0);

bool cpp_begin_template_declaration (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_template_parameter_list (
        CppElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_template_declaration (
        Cpp_TemplateDeclaration *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TemplateDeclaration : public CppElement
{
public:
    Cpp_TemplateParameterList *templateParameterList;
    Cpp_Declaration *declaration;

    Cpp_TemplateDeclaration ()
        : CppElement (CppElement::_TemplateDeclaration)
          , templateParameterList (NULL)
          , declaration (NULL)
    {
    }
};

void dump_cpp_TemplateDeclaration (Cpp_TemplateDeclaration const *, MyCpp::Size nest_level = 0);

class Cpp_TemplateParameterList : public CppElement
{
public:
    enum Type {
        _TemplateParameterList,
        _TemplateParameter
    };

    const Type template_parameter_list_type;

    Cpp_TemplateParameterList (Type type)
        : CppElement (CppElement::_TemplateParameterList),
          template_parameter_list_type (type)
    {
    }
};

class Cpp_TemplateParameterList_TemplateParameterList : public Cpp_TemplateParameterList
{
public:
    Cpp_TemplateParameter *templateParameter;
    Cpp_TemplateParameterList *templateParameterList;

    Cpp_TemplateParameterList_TemplateParameterList ()
        : Cpp_TemplateParameterList (Cpp_TemplateParameterList::_TemplateParameterList)
          , templateParameter (NULL)
          , templateParameterList (NULL)
    {
    }
};

class Cpp_TemplateParameterList_TemplateParameter : public Cpp_TemplateParameterList
{
public:
    Cpp_TemplateParameter *templateParameter;

    Cpp_TemplateParameterList_TemplateParameter ()
        : Cpp_TemplateParameterList (Cpp_TemplateParameterList::_TemplateParameter)
          , templateParameter (NULL)
    {
    }
};

void dump_cpp_TemplateParameterList (Cpp_TemplateParameterList const *, MyCpp::Size nest_level = 0);

class Cpp_TemplateParameter : public CppElement
{
public:
    enum Type {
        _TypeParameter,
        _ParameterDeclaration
    };

    const Type template_parameter_type;

    Cpp_TemplateParameter (Type type)
        : CppElement (CppElement::_TemplateParameter),
          template_parameter_type (type)
    {
    }
};

class Cpp_TemplateParameter_TypeParameter : public Cpp_TemplateParameter
{
public:
    Cpp_TypeParameter *typeParameter;

    Cpp_TemplateParameter_TypeParameter ()
        : Cpp_TemplateParameter (Cpp_TemplateParameter::_TypeParameter)
          , typeParameter (NULL)
    {
    }
};

class Cpp_TemplateParameter_ParameterDeclaration : public Cpp_TemplateParameter
{
public:
    Cpp_ParameterDeclaration *parameterDeclaration;

    Cpp_TemplateParameter_ParameterDeclaration ()
        : Cpp_TemplateParameter (Cpp_TemplateParameter::_ParameterDeclaration)
          , parameterDeclaration (NULL)
    {
    }
};

void dump_cpp_TemplateParameter (Cpp_TemplateParameter const *, MyCpp::Size nest_level = 0);

bool cpp_accept_type_template_parameter (
        Cpp_TypeParameter *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TypeParameter : public CppElement
{
public:
    enum Type {
        _Class_Default,
        _Class,
        _Typename_Default,
        _Typename,
        _Template_Default,
        _Template
    };

    const Type type_parameter_type;

    Cpp_TypeParameter (Type type)
        : CppElement (CppElement::_TypeParameter),
          type_parameter_type (type)
    {
    }
};

bool cpp_accept_type_template_parameter (
        Cpp_TypeParameter *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TypeParameter_Class_Default : public Cpp_TypeParameter
{
public:
    Cpp_Identifier *identifier;
    Cpp_TypeId *typeId;

    Cpp_TypeParameter_Class_Default ()
        : Cpp_TypeParameter (Cpp_TypeParameter::_Class_Default)
          , identifier (NULL)
          , typeId (NULL)
    {
    }
};

class Cpp_TypeParameter_Class : public Cpp_TypeParameter
{
public:
    Cpp_Identifier *identifier;

    Cpp_TypeParameter_Class ()
        : Cpp_TypeParameter (Cpp_TypeParameter::_Class)
          , identifier (NULL)
    {
    }
};

class Cpp_TypeParameter_Typename_Default : public Cpp_TypeParameter
{
public:
    Cpp_Identifier *identifier;
    Cpp_TypeId *typeId;

    Cpp_TypeParameter_Typename_Default ()
        : Cpp_TypeParameter (Cpp_TypeParameter::_Typename_Default)
          , identifier (NULL)
          , typeId (NULL)
    {
    }
};

class Cpp_TypeParameter_Typename : public Cpp_TypeParameter
{
public:
    Cpp_Identifier *identifier;

    Cpp_TypeParameter_Typename ()
        : Cpp_TypeParameter (Cpp_TypeParameter::_Typename)
          , identifier (NULL)
    {
    }
};

class Cpp_TypeParameter_Template_Default : public Cpp_TypeParameter
{
public:
    Cpp_TemplateParameterList *templateParameterList;
    Cpp_Identifier *identifier;
    Cpp_IdExpression *idExpression;

    Cpp_TypeParameter_Template_Default ()
        : Cpp_TypeParameter (Cpp_TypeParameter::_Template_Default)
          , templateParameterList (NULL)
          , identifier (NULL)
          , idExpression (NULL)
    {
    }
};

class Cpp_TypeParameter_Template : public Cpp_TypeParameter
{
public:
    Cpp_TemplateParameterList *templateParameterList;
    Cpp_Identifier *identifier;

    Cpp_TypeParameter_Template ()
        : Cpp_TypeParameter (Cpp_TypeParameter::_Template)
          , templateParameterList (NULL)
          , identifier (NULL)
    {
    }
};

void dump_cpp_TypeParameter (Cpp_TypeParameter const *, MyCpp::Size nest_level = 0);

bool cpp_begin_template_id (
        Cpp_TemplateId *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool cpp_accept_template_id (
        Cpp_TemplateId *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TemplateId : public CppElement
{
public:
    Cpp_TemplateName *templateName;
    Cpp_TemplateArgumentList *templateArgumentList;

    Cpp_TemplateId ()
        : CppElement (CppElement::_TemplateId)
          , templateName (NULL)
          , templateArgumentList (NULL)
    {
    }
};

void dump_cpp_TemplateId (Cpp_TemplateId const *, MyCpp::Size nest_level = 0);

class Cpp_TemplateName : public CppElement
{
public:
    Cpp_Identifier *identifier;

    Cpp_TemplateName ()
        : CppElement (CppElement::_TemplateName)
          , identifier (NULL)
    {
    }
};

void dump_cpp_TemplateName (Cpp_TemplateName const *, MyCpp::Size nest_level = 0);

class Cpp_TemplateArgumentList : public CppElement
{
public:
    enum Type {
        _TemplateArgumentList,
        _TemplateArgument
    };

    const Type template_argument_list_type;

    Cpp_TemplateArgumentList (Type type)
        : CppElement (CppElement::_TemplateArgumentList),
          template_argument_list_type (type)
    {
    }
};

class Cpp_TemplateArgumentList_TemplateArgumentList : public Cpp_TemplateArgumentList
{
public:
    Cpp_TemplateArgument *templateArgument;
    Cpp_TemplateArgumentList *templateArgumentList;

    Cpp_TemplateArgumentList_TemplateArgumentList ()
        : Cpp_TemplateArgumentList (Cpp_TemplateArgumentList::_TemplateArgumentList)
          , templateArgument (NULL)
          , templateArgumentList (NULL)
    {
    }
};

class Cpp_TemplateArgumentList_TemplateArgument : public Cpp_TemplateArgumentList
{
public:
    Cpp_TemplateArgument *templateArgument;

    Cpp_TemplateArgumentList_TemplateArgument ()
        : Cpp_TemplateArgumentList (Cpp_TemplateArgumentList::_TemplateArgument)
          , templateArgument (NULL)
    {
    }
};

void dump_cpp_TemplateArgumentList (Cpp_TemplateArgumentList const *, MyCpp::Size nest_level = 0);

bool cpp_accept_template_argument (
        Cpp_TemplateArgument *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TemplateArgument : public CppElement
{
public:
    enum Type {
        _TypeId,
        _AssignmentExpression,
        _IdExpression
    };

    const Type template_argument_type;

    Cpp_TemplateArgument (Type type)
        : CppElement (CppElement::_TemplateArgument),
          template_argument_type (type)
    {
    }
};

bool cpp_accept_template_argument (
        Cpp_TemplateArgument *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_TemplateArgument_TypeId : public Cpp_TemplateArgument
{
public:
    Cpp_TypeId *typeId;

    Cpp_TemplateArgument_TypeId ()
        : Cpp_TemplateArgument (Cpp_TemplateArgument::_TypeId)
          , typeId (NULL)
    {
    }
};

class Cpp_TemplateArgument_AssignmentExpression : public Cpp_TemplateArgument
{
public:
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_TemplateArgument_AssignmentExpression ()
        : Cpp_TemplateArgument (Cpp_TemplateArgument::_AssignmentExpression)
          , assignmentExpression (NULL)
    {
    }
};

class Cpp_TemplateArgument_IdExpression : public Cpp_TemplateArgument
{
public:
    Cpp_IdExpression *idExpression;

    Cpp_TemplateArgument_IdExpression ()
        : Cpp_TemplateArgument (Cpp_TemplateArgument::_IdExpression)
          , idExpression (NULL)
    {
    }
};

void dump_cpp_TemplateArgument (Cpp_TemplateArgument const *, MyCpp::Size nest_level = 0);

class Cpp_ExplicitInstantiation : public CppElement
{
public:
    Cpp_Declaration *declaration;

    Cpp_ExplicitInstantiation ()
        : CppElement (CppElement::_ExplicitInstantiation)
          , declaration (NULL)
    {
    }
};

void dump_cpp_ExplicitInstantiation (Cpp_ExplicitInstantiation const *, MyCpp::Size nest_level = 0);

class Cpp_ExplicitSpecialization : public CppElement
{
public:
    Cpp_Declaration *declaration;

    Cpp_ExplicitSpecialization ()
        : CppElement (CppElement::_ExplicitSpecialization)
          , declaration (NULL)
    {
    }
};

void dump_cpp_ExplicitSpecialization (Cpp_ExplicitSpecialization const *, MyCpp::Size nest_level = 0);

class Cpp_TryBlock : public CppElement
{
public:
    Cpp_CompoundStatement *compoundStatement;
    Cpp_HandlerSeq *handlerSeq;

    Cpp_TryBlock ()
        : CppElement (CppElement::_TryBlock)
          , compoundStatement (NULL)
          , handlerSeq (NULL)
    {
    }
};

void dump_cpp_TryBlock (Cpp_TryBlock const *, MyCpp::Size nest_level = 0);

class Cpp_FunctionTryBlock : public CppElement
{
public:
    Cpp_CtorInitializer *ctorInitializer;
    Cpp_FunctionBody *functionBody;
    Cpp_HandlerSeq *handlerSeq;

    Cpp_FunctionTryBlock ()
        : CppElement (CppElement::_FunctionTryBlock)
          , ctorInitializer (NULL)
          , functionBody (NULL)
          , handlerSeq (NULL)
    {
    }
};

void dump_cpp_FunctionTryBlock (Cpp_FunctionTryBlock const *, MyCpp::Size nest_level = 0);

class Cpp_HandlerSeq : public CppElement
{
public:
    Cpp_Handler *handler;
    Cpp_HandlerSeq *handlerSeq;

    Cpp_HandlerSeq ()
        : CppElement (CppElement::_HandlerSeq)
          , handler (NULL)
          , handlerSeq (NULL)
    {
    }
};

void dump_cpp_HandlerSeq (Cpp_HandlerSeq const *, MyCpp::Size nest_level = 0);

class Cpp_Handler : public CppElement
{
public:
    enum Type {
        _Default,
        _ClassPrematch
    };

    const Type handler_type;

    Cpp_Handler (Type type)
        : CppElement (CppElement::_Handler),
          handler_type (type)
    {
    }
};

class Cpp_Handler_Default : public Cpp_Handler
{
public:
    Cpp_ExceptionDeclaration *exceptionDeclaration;
    Cpp_CompoundStatement *compoundStatement;

    Cpp_Handler_Default ()
        : Cpp_Handler (Cpp_Handler::_Default)
          , exceptionDeclaration (NULL)
          , compoundStatement (NULL)
    {
    }
};

class Cpp_Handler_ClassPrematch : public Cpp_Handler
{
public:
    Cpp_Scruffy_SkipExceptionDeclaration *scruffy_SkipExceptionDeclaration;
    Cpp_Scruffy_SkipCompoundStatement *scruffy_SkipCompoundStatement;

    Cpp_Handler_ClassPrematch ()
        : Cpp_Handler (Cpp_Handler::_ClassPrematch)
          , scruffy_SkipExceptionDeclaration (NULL)
          , scruffy_SkipCompoundStatement (NULL)
    {
    }
};

void dump_cpp_Handler (Cpp_Handler const *, MyCpp::Size nest_level = 0);

class Cpp_ExceptionDeclaration : public CppElement
{
public:
    enum Type {
        _Declarator,
        _Ellipsis
    };

    const Type exception_declaration_type;

    Cpp_ExceptionDeclaration (Type type)
        : CppElement (CppElement::_ExceptionDeclaration),
          exception_declaration_type (type)
    {
    }
};

class Cpp_ExceptionDeclaration_Declarator : public Cpp_ExceptionDeclaration
{
public:
    Cpp_TypeSpecifierSeq *typeSpecifierSeq;
    Cpp_Declarator *declarator;

    Cpp_ExceptionDeclaration_Declarator ()
        : Cpp_ExceptionDeclaration (Cpp_ExceptionDeclaration::_Declarator)
          , typeSpecifierSeq (NULL)
          , declarator (NULL)
    {
    }
};

class Cpp_ExceptionDeclaration_Ellipsis : public Cpp_ExceptionDeclaration
{
public:

    Cpp_ExceptionDeclaration_Ellipsis ()
        : Cpp_ExceptionDeclaration (Cpp_ExceptionDeclaration::_Ellipsis)
    {
    }
};

void dump_cpp_ExceptionDeclaration (Cpp_ExceptionDeclaration const *, MyCpp::Size nest_level = 0);

bool cpp_accept_throw_expression (
        Cpp_ThrowExpression *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

class Cpp_ThrowExpression : public CppElement
{
public:
    Cpp_AssignmentExpression *assignmentExpression;

    Cpp_ThrowExpression ()
        : CppElement (CppElement::_ThrowExpression)
          , assignmentExpression (NULL)
    {
    }
};

void dump_cpp_ThrowExpression (Cpp_ThrowExpression const *, MyCpp::Size nest_level = 0);

class Cpp_ExceptionSpecification : public CppElement
{
public:
    Cpp_TypeIdList *typeIdList;

    Cpp_ExceptionSpecification ()
        : CppElement (CppElement::_ExceptionSpecification)
          , typeIdList (NULL)
    {
    }
};

void dump_cpp_ExceptionSpecification (Cpp_ExceptionSpecification const *, MyCpp::Size nest_level = 0);

class Cpp_TypeIdList : public CppElement
{
public:
    enum Type {
        _TypeIdList,
        _TypeId
    };

    const Type type_id_list_type;

    Cpp_TypeIdList (Type type)
        : CppElement (CppElement::_TypeIdList),
          type_id_list_type (type)
    {
    }
};

class Cpp_TypeIdList_TypeIdList : public Cpp_TypeIdList
{
public:
    Cpp_TypeId *typeId;
    Cpp_TypeIdList *typeIdList;

    Cpp_TypeIdList_TypeIdList ()
        : Cpp_TypeIdList (Cpp_TypeIdList::_TypeIdList)
          , typeId (NULL)
          , typeIdList (NULL)
    {
    }
};

class Cpp_TypeIdList_TypeId : public Cpp_TypeIdList
{
public:
    Cpp_TypeId *typeId;

    Cpp_TypeIdList_TypeId ()
        : Cpp_TypeIdList (Cpp_TypeIdList::_TypeId)
          , typeId (NULL)
    {
    }
};

void dump_cpp_TypeIdList (Cpp_TypeIdList const *, MyCpp::Size nest_level = 0);

class Cpp_Grammar : public CppElement
{
public:
    Cpp_TranslationUnit *translationUnit;

    Cpp_Grammar ()
        : CppElement (CppElement::_Grammar)
          , translationUnit (NULL)
    {
    }
};

MyCpp::Ref<Pargen::Grammar> create_cpp_grammar ();

void dump_cpp_grammar (Cpp_Grammar const *el);

}

#endif /* __SCRUFFY__CPP_PARGEN_H__ */

